#include <bits/stdc++.h>
using namespace std;

int n, m;
const int MAXN = 1e5+1;
vector<pair<int, int>> v[MAXN];
vector<int> ans;
multiset<pair<int, int>> path;

void Dfs(int k) {
    for(int i=0;i<v[k].size();i++) {
        int to = v[k][i].first;
        int nom = v[k][i].second;
        if(path.find({k, to}) != path.end()) path.erase(path.find({k, to}));
        else
        if(path.find({to, k}) != path.end()) path.erase(path.find({to, k}));
        else  continue;

        ans.push_back(nom);
        Dfs(to);
        if(v[to].size() == 0)
            ans.push_back(nom);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);  cout.tie(NULL);
    int i;
    cin>>n>>m;
    for(i=1;i<=m;i++) {
        int p, q, t;
        cin>>p>>q>>t;
        v[p].push_back({q, i});
        v[q].push_back({p, i});
        path.insert({p, q});
        //br[p]++; br[q]++;
    }
   /* for(i=1;i<=n;i++) {
        if(br[i]%2 != 0) {
            cout<<-1<<endl;
            return 0;
        }
    }*/
    Dfs(1);
    cout<<ans.size()<<'\n';
    for(i=0;i<ans.size();i++)
        cout<<ans[i]<<' ';

    return 0;
}
/*
10 10
1 10 2
10 7 2
7 5 2
7 9 2
9 2 2
2 6 2
2 8 2
6 8 2
6 3 2
5 3 2
*/

/*
6 9
1 5 1
1 2 1
1 4 1
1 3 1
4 5 1
3 2 1
2 5 1
6 5 1
2 6 1
*/
