#include<iostream>
#include<vector>
#include<tuple>
using namespace std;

const int MAXN=1e5;

struct node
{
    int passLeft;
    bool visited;
};

vector<node> nodes;
vector<pair<int, int> > graph[MAXN];

bool EqualNodes(int idx)
{
    int m=graph[idx].size();
    if(m%2==0)
    {
        return true;
    }

    for(int i=0; i<m; i++)
    {
        int target, nodeIdx;
        tie(target, nodeIdx)=graph[idx][i];

        if(nodes[nodeIdx].passLeft!=0)
        {
            nodes[nodeIdx].passLeft=0;
            nodes.push_back({0, false});
            graph[idx].push_back({target, nodes.size()-1});
            graph[target].push_back({i, nodes.size()-1});

            return EqualNodes(target);
        }
    }

    return false;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    cout << -1 << "\n";
    return 0;

    for(int i=0; i<m; i++)
    {
        int a, b, t;
        cin >> a >> b >> t;
        a--, b--;

        nodes.push_back({t-1, false});
        graph[a].push_back({b, i});
        graph[b].push_back({a, i});
    }

    for(int i=0; i<n; i++)
    {
        if(graph[i].size()%2!=0)
        {
            if(!EqualNodes(i))
            {
                cout << "-1\n";

                return 0;
            }
        }
    }

    cout << "1\n";

    return 0;
}
