// #pragma GCC optimize ("O3")
// #pragma GCC target ("avx2", "popcnt")

#include <bits/stdc++.h>
#define endl "\n"
#define llong long long
using namespace std;

const int maxn = 25e+4+4;

const llong p27[11] = {
    1, 27, 729, 19683,
    531441, 14348907,
    387420489, 10460353203,
    282429536481, 7625597484987,
    205891132094649};

void input();
void solve();
void print();
llong hfunc(const string& str);
void uhfunc(llong hashed_str);

// hashed string - index
unordered_map<llong, llong> keys;
vector<llong> values[maxn];

vector<string> names;
vector<llong> hashed_skeys;
vector<llong> sums;

vector<llong> indeces;
llong n, m, k;

int main()
{
    input();
    solve();
    print();
    return 0;
}

void input()
{
    // ios_base::sync_with_stdio(0);
    // cin.tie(0);
    cin >> n >> m >> k;
    string skey; llong key, hashed_key;
    for(llong i = 0; i < n; i++)
    {
        cin >> skey;
        names.emplace_back(skey);

        hashed_key = hfunc(skey);
        hashed_skeys.emplace_back(hashed_key);
        keys[hashed_key] = i;

        indeces.emplace_back(i);

        for(llong j = 0; j < k; j++)
            values[i].emplace_back(0);
    }

    llong stask;
    for(llong i = 0; i < m; i++)
    {
        cin >> skey; key = keys[hfunc(skey)];
        for(llong j = 0; j < k; j++)
        {
            cin >> stask;
            values[key][j] = max(values[key][j], stask);
        }
    }

    llong sum;
    for(llong i = 0; i < n; i++)
    {
        sum = 0;
        for(llong j = 0; j < k; j++) sum += values[i][j];
        sums.emplace_back(sum);
    }
}

void solve()
{
    sort(indeces.begin(), indeces.end(),
    [](llong a, llong b)
    {
        if(sums[a] > sums[b]) return true;
        if(sums[a] == sums[b] && hashed_skeys[a] < hashed_skeys[b]) return true;
        return false;
    }
    );
}

void print()
{
    llong key;
    for(llong i = 0; i < n; i++)
    {
        key = indeces[i];
        cout << names[key] << " " << sums[key] << " ";
        for(llong j = 0; j < k; j++)
            cout << values[key][j] << " ";
        cout << endl;
    }
}

llong hfunc(const string& str)
{
    llong answer = 0, k = 0;
    for(size_t i = str.size(); i > 0; i--)
    {
        answer += p27[k] * (llong)(str[i-1]-'a'+1);
        k++;
    }
    return answer;
}
