#include<iostream>
#include<math.h>
#include<algorithm>
#include<map>
#include <unordered_map>

using namespace std;

class Competitor2
{
public:
    int totalPoints;

    string name;
};

class Competitor
{
public:
    void Initialise()
    {
        for(int i = 0;i < 6;i++)
        {
            points[i] = 0;
        }
    }

    int totalPoints = 0;

    string name;

    int points[6];

    void SetPoints(int index, int p)
    {
        if(points[index] < p)
        {
            totalPoints -= points[index];

            points[index] = p;

            totalPoints += points[index];
        }
    }
};

unordered_map<string, Competitor> a;

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL);
    int n,m,k;

    cin>>n>>m>>k;

    Competitor2 cp[n];

    for(int i = 0;i < n;i++)
    {
        Competitor c;

        cin>>c.name;

        c.Initialise();

        cp[i].name = c.name;

        a[c.name] = c;
    }

    for(int i = 0;i < m;i++)
    {
        string name;
        cin>>name;

        for(int j = 0;j < k;j++)
        {
            int newPoints;

            cin>>newPoints;
            a[name].SetPoints(j, newPoints);
        }
    }

    int index = 0;

    for(int i = 0;i < n;i++)
    {
        //cout<<cp[i].name;
        cp[i].totalPoints = a[cp[i].name].totalPoints;
        //cout<<" "<<cp[i].totalPoints<<endl;
    }

    struct {
        bool operator()(Competitor2 k1, Competitor2 k2)
{
    if(k1.totalPoints != k2.totalPoints)
    {
        return k1.totalPoints > k2.totalPoints;
    }

    return k1.name < k2.name;
}
    } customLess;

    sort(cp, cp + n, customLess);

    for(int i = 0;i < n;i++)
    {
        cout<<cp[i].name<<" "<<cp[i].totalPoints;

        for(int j = 0;j < k;j++)
        {
            cout<<" "<<a[cp[i].name].points[j];
        }

        cout<<endl;
    }
}
