#include<bits/stdc++.h>
using namespace std;

const int maxn = 250002, maxk = 8;
int n, m, k;
long long p[maxn][maxk];
unordered_map <string, int> names;
struct person
{
    long long total;
    int idx;
    string name;
};
person ans[maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m >> k;
    string s;
    for (int i=1; i<=n; ++i)
    {
        cin >> s;
        names[s] = i;
        ans[i].name = s;
        ans[i].idx = i;
    }
}

bool cmp(person p1, person p2)
{
    if (p1.total == p2.total) return (p1.name < p2.name);
    return (p1.total > p2.total);
}

void solve()
{
    int i, j, num;
    long long v;
    string s;
    for (i=1; i<=m; ++i)
    {
        cin >> s ;
        num = names[s];
        for (j=1; j<=k; ++j)
        {
            cin >> v ;
            if (p[num][j] < v)
            {
                ans[num].total += (v - p[num][j]);
                p[num][j] = v;
            }
        }
    }
    sort(ans+1, ans+n+1, cmp);
}

void print()
{
    for (int i=1; i<=n; ++i)
    {
        cout << ans[i].name << " " << ans[i].total ;
        for (int j=1; j<=k; ++j) cout << " " << p[ans[i].idx][j] ;
        cout << '\n' ;
    }
}

int main()
{
    read();
    solve();
    print();
    return 0;
}
