#include<bits/stdc++.h>
using namespace std;

const int maxn = 1e5+2, maxm = 1e6+2;
int n, m, st[maxn];
bool used[maxn];
vector <int> v[maxn];
unordered_map <long long, pair <int, vector<int> > > mymap;
unordered_map <long long, int> idx;

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    int i, u, vv, t;
    long long h;
    for (i=1; i<=m; ++i)
    {
        cin >> u >> vv >> t ;
        ++ st[vv];
        ++ st[u];
        v[u].push_back(vv);
        v[vv].push_back(u);
        if (u < vv) swap(u, vv);
        h = 1e6*u + vv;
        mymap[h].first += t;
        mymap[h].second.push_back(i);
        idx[h] = 1;
    }
}

void check()
{
    for (int i=1; i<=n; ++i)
    {
        if (st[i]&1)
        {
            cout << "-1" << '\n' ;
            exit(0);
        }
    }
}

void solve()
{
    stack<int> s, fs;
    s.push(1);
    int w, j, len, nb;
    long long h;
    while (!s.empty())
    {
        w = s.top();
        len = v[w].size();
        for (j=0; j<len; ++j)
        {
            nb = v[w][j];
            if (w < nb) h = 1e6*nb + w;
            else h = 1e6*w + nb;
            if (mymap[h].first > 0) break;
        }

        if (j == len)
        {
            s.pop();
            fs.push(w);
        }
        else
        {
            s.push(nb);
            if (w < nb) h = 1e6*nb + w;
            else h = 1e6*w + nb;
            -- mymap[h].first;
        }
    }

    cout << fs.size() << endl ;
    int pr = fs.top(), t;
    fs.pop();
    while (!fs.empty())
    {
        t = fs.top();
        fs.pop();
        if (pr > t) h = 1e6*pr + t;
        else h = 1e6*t + pr;
        cout << mymap[h].second[idx[h]-1] << " " ;
        ++ idx[h];
        pr = t;
    }
    cout << '\n' ;
}

int main()
{
    read();
    check();
    solve();
    return 0;
}

/*
5 7
1 2 1
2 5 2
5 2 2
5 1 1
2 3 1
4 3 1
4 5 1
*/
