#include<bits/stdc++.h>
using namespace std;
const int maxn = 1000001;
struct edge
{
    int ver;
    int type;
    int idx;

    edge(){};
    edge( int ver1, int type1, int idx1 )
    {
        ver = ver1;
        type = type1;
        idx = idx1;
    }

    bool operator < ( const edge & e ) const
    {
        return ( idx < e.idx );
    }
};

int n,m;
set<edge>s[maxn];
int pw[maxn];

vector<int>ans1;
vector<int>ans2;

void read()
{
    cin >> n >> m;
    for( int i = 1; i <= m; i ++ )
    {
        int x,y,z;
        cin >> x >> y >> z;

        s[x].insert(edge(y,z,i));
        s[y].insert(edge(x,z,i));

        pw[x] += 1;
        pw[y] += 1;
    }


    /*
    for( int i = 1; i <= n; i ++ )
    {
        cout << i << " : " << '\n';
        for( set<edge>::iterator it = s[i].begin(); it != s[i].end(); it ++ )
        {
            edge te = * it;
            cout << te.ver << " " << te.idx << '\n';
        }
        cout << '\n';
    }
    */

    for( int i = 1; i <= n; i ++ )
    {
        if( pw[i] % 2 == 1 )
        {
            cout << -1 << '\n';
            exit(0);
        }
    }

    cout << 1 << '\n';
}

void solve()
{
    stack<int>s1;
    stack<int>s2;

    s1.push(1);
    s2.push(0);

    while( !s1.empty() )
    {
        int nb = s1.top();
        int nb_idx = s2.top();

        //cout << nb << '\n';

        int lamp = 0;
        for( set<edge>::iterator it = s[nb].begin(); it != s[nb].end(); it ++ )
        {
            edge te = * it;

            int x = te.ver;
            int y = te.idx;

            s1.push(x);
            s2.push(y);

            lamp = 1;

            s[nb].erase(it);

            edge te1;

            te1.ver = nb;
            te1.type = te.type;
            te1.idx = y;

            set<edge>::iterator it1 = s[x].find(te1);
            s[x].erase(it1);

            break;
        }

        //cout << nb << '\n';

        if( lamp == 0 )
        {
            ans1.push_back(nb);
            s1.pop();

            if( nb_idx != 0 )ans2.push_back(nb_idx);
            s2.pop();

            continue;
        }
    }

    for( int i = 0; i < ans1.size(); i ++ )
    {
        cout << ans1[i] << " ";
    }
    cout << '\n';

    for( int i = 0; i < ans2.size(); i ++ )
    {
        cout << ans2[i] << " ";
    }
    cout << '\n';
}
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int main()
{
    speed();
    read();
    //solve();
    return 0;
}
