#include<bits/stdc++.h>
using namespace std;
const int maxn = 1000001;
struct edge
{
    int ver;
    int type;
    int idx;

    edge() {};
    edge( int ver1, int type1, int idx1)
    {
        ver = ver1;
        type = type1;
        idx = idx1;
    }

    bool operator < ( const edge & e ) const
    {
        return ( idx < e.idx );
    }
};

int n,m;
vector<edge>v[maxn];
int pw[maxn];
int p[maxn];

vector<int>ans1;
vector<int>ans2;

int used[maxn];
int big_lamp = 0;

int tp[maxn];
int perm[maxn];

int from[maxn];
int to[maxn];

void read()
{
    cin >> n >> m;
    for( int i = 1; i <= m; i ++ )
    {
        int x,y,z;
        cin >> x >> y >> z;

        tp[i] = z;
        from[i] = x;
        to[i] = y;

        if( z == 2 ) big_lamp = 1;

        v[x].push_back(edge(y,z,i));
        v[y].push_back(edge(x,z,i));

        if( z == 1 )
        {
            pw[x] += 1;
            pw[y] += 1;
        }
        else
        {
            pw[x] += 2;
            pw[y] += 2;
        }
    }


    /*
    for( int i = 1; i <= n; i ++ )
    {
        cout << i << " : " << '\n';
        for( int j = 0; j < v[i].size(); j ++ )
        {
           cout << v[i][j].ver << " " << v[i][j].type << " " << v[i][j].idx << " " << v[i][j].rev << endl;
        }
        cout << '\n';
    }
    */

    //cout << 1 << '\n';
}

void solve()
{
    stack<int>s1;
    stack<int>s2;

    s1.push(1);
    s2.push(0);

    while( !s1.empty() )
    {
        int nb = s1.top();
        int nb_idx = s2.top();

        int sz = v[nb].size();

        // cout << nb << endl;

        int lamp = 0;
        while( p[nb] < sz )
        {

            int x = v[nb][p[nb]].ver;
            int y = v[nb][p[nb]].idx;

            if( used[y] == 0 )
            {
                used[y] += 1;

                s1.push(x);
                s2.push(y);

                lamp = 1;
                break;
            }

            p[nb] += 1;
        }

        if( lamp < 2 )
        {
            ans1.push_back(nb);
            s1.pop();

            if( nb_idx != 0 )ans2.push_back(nb_idx);
            s2.pop();

            continue;
        }
    }

    /*
    for( int i = 0; i < ans1.size(); i ++ )
    {
        cout << ans1[i] << " ";
    }
    cout << '\n';
    */

    int sz = ans2.size();
    if( ans2[sz-1] != 1 )
    {
        cout << 1 / 0 << endl;
        exit(0);
    }

    cout << ans2.size() << endl;
    for( int i = 0; i < ans2.size(); i ++ )
    {
        cout << ans2[i] << " ";
    }
    cout << '\n';
}

void solve1( int pos )
{
    if( pos > m )
    {
        memset(pw,0,sizeof(pw));

        for( int i = 1; i <= m; i ++ )
        {
            pw[ from[i] ] += perm[i];
            pw[ to[i] ] += perm[i];
        }

        for( int i = 1; i <= n; i ++ )
        {
            if( pw[i] % 2 == 1)
            {
                return;
            }
        }

        for( int i = 1; i <= m; i ++ )
        {
            if( perm[i] == 2 )
            {
                int x = from[i];
                int y = to[i];

                v[x].push_back(edge(y,tp[i],i));
                v[y].push_back(edge(x,tp[i],i));
            }
        }

        solve();
        exit(0);
        return;
    }

    if( tp[pos] == 1 )
    {
        perm[pos] = 1;
        solve1(pos+1);
    }
    else
    {
        for( int i = 1; i <= 2; i ++ )
        {
            perm[pos] = i;
            solve1(pos+1);
        }
    }
}

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int main()
{
    speed();
    read();
    solve1(1);
    cout << -1 << endl;
    return 0;
}
