#include<bits/stdc++.h>
using namespace std;
const int maxn=(1<<18);
unordered_map<string,int>names;
unordered_map<int,string>idxes;
int k;
struct comp{
    int idx,mpoints;
    vector<int>subs;
    comp(){
        idx=0;
        mpoints=0;
    }
    comp(int _idx){
        idx=_idx;
        mpoints=0;
        subs.resize(k);
    }
    void newsub(vector<int> _new){
        int points=0,k=_new.size();
        for(int i=0;i<k;++i){
            /*if(subs[i]<_new[i])
                subs[i]=_new[i];*/
            subs[i]=max(subs[i],_new[i]);
            //points+=subs[i];
        }
        //mpoints=points;
    }
    void find_mpoints(){
        for(int i=0;i<k;++i)
            mpoints+=subs[i];
    }
    bool operator<(const comp &other)const{
        if(mpoints==other.mpoints){
            string s1=idxes[idx];
            string s2=idxes[other.idx];
            return s1<s2;
        }
        return mpoints<other.mpoints;
    }
    bool operator>(const comp &other)const{
        if(mpoints==other.mpoints){
            string s1=idxes[idx];
            string s2=idxes[other.idx];
            return s1<s2;
        }
        return mpoints>other.mpoints;
    }
};
int n,m;
comp a[maxn];
void read(){
    cin >> n >> m >> k;
    string s;
    vector<int>v;
    v.resize(k);
    for(int i=1;i<=n;++i){
        cin>>s;
        names[s]=i;
        idxes[i]=s;
        //a[i]=comp(i,0,k);
        a[i].subs.resize(k);
        a[i].idx=i;
        a[i].mpoints=0;
    }
    for(int i=1;i<=m;++i){
        cin>>s;
        int idx=names[s],w;
        for(int sub=0;sub<k;++sub)
            cin>>v[sub];
        a[idx].newsub(v);
    }
}
bool cmp(comp c,comp d){
    if(c.mpoints==d.mpoints){
        string s1=idxes[c.idx];
        string s2=idxes[d.idx];

        int sz=min(s1.size(),s2.size());
        for(int i=0;i<sz;++i){
            //if(s1[i]==s2[i])continue;
            if(s1[i]<s2[i])return true;
            if(s1[i]>s2[i])return false;
        }
        if(s1.size()<s2.size())return true;
        else return false;
    }
    return c.mpoints>d.mpoints;
}
void print(){
    for(int i=1;i<=n;++i)
        a[i].find_mpoints();
    sort(a+1,a+1+n,cmp);
    for(int i=1;i<=n;++i){
        string name=idxes[a[i].idx];
        cout<<name<<" "<<a[i].mpoints;
        for(int sub=0;sub<k;++sub)
            cout<<" "<<a[i].subs[sub];
        cout<<endl;
    }
}
int main()
{
    /*ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);*/
    read();
    print();
return 0;
}
/*
5 6 2
benq
tourist
radewoosh
maroonrk
sorting

sorting 40 10
tourist 50 50
maroonrk 20 30
sorting 20 150
tourist 150 0
radewoosh 25 25
*/
