#include <bits/stdc++.h>

typedef long long ll;
const ll MAX_N = 2e5 + 10;
const ll MAX_K = 5;

struct prob {
    ll cnt[MAX_K];
    ll sum;

    prob() {
        for(ll i = 0; i < MAX_K; i ++) {
            cnt[i] = 0;
        }
        sum = 0;
    }

    void set(ll ind, ll val) {
        sum -= cnt[ind];
        cnt[ind] = std::max(cnt[ind], val);
        sum += cnt[ind];
    }
};

std::map<std::string, prob> cnt;
std::string names[MAX_N];
ll n, m, k;

signed main() {

    std::cin >> n >> m >> k;
    for(ll i = 0; i < n; i ++) {
        std::cin >> names[i];
        cnt[names[i]] = prob();
    }

    for(ll i = 0; i < m; i ++) {
        std::string name;
        std::cin >> name;
        for(ll j = 0; j < k; j ++) {
            ll v;
            std::cin >> v;
            cnt[name].set(j, v);
        }
    }

    std::vector<std::pair<ll, std::string> > to_sort;
    for(const auto &it : cnt) {
        to_sort.push_back(std::make_pair(-it.second.sum, it.first));
    }

    std::sort(to_sort.begin(), to_sort.end());
    for(ll i = 0; i < n; i ++) {
        std::cout << to_sort[i].second << " " << -to_sort[i].first << " ";
        for(ll j = 0; j < k; j ++) {
            std::cout << cnt[to_sort[i].second].cnt[j] << " ";
        }
        std::cout << "\n";
    }

    return 0;
}
