#include <iostream>
#include <unordered_map>
using namespace std;
const int MAXN=2e5+10;
const long long stepen=31;
const long long mod=1e9+7;
string str[16];
int n, k;
unordered_map <long long, int> um[16];
long long h[16][MAXN], st[MAXN];
void precomp() {
    for (int i=0;i<k;i++) {
        h[i][0]=str[i][0]-'a';
        for (int j=1;j<2*n;j++) {
            h[i][j]=((h[i][j-1]*stepen)%mod+str[i][j]-'a')%mod;
        }
    }
    st[0]=1;
    for (int i=1;i<=2*n;i++) st[i]=(st[i-1]*stepen)%mod;
}
bool check(int len) {
    long long curh;
    for (int i=0;i<k;i++) {
        if (!um[i].empty()) um[i].clear();
        for (int j=0;j<n+len;j++) {
            if (j>=len-1) {
                if (j==len-1) curh=h[i][j];
                else curh=(h[i][j]-(h[i][j-len]*st[len])%mod+mod)%mod;
                um[i][curh]=1;
                if (i>0 && um[i-1][curh]!=1) um[i][curh]=-1;
                if (i==k-1 && um[i][curh]==1) return true;
            }
        }
    }
    return false;
}
int main () {
    /**
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);**/
    cin >> n >> k;
    for (int i=0;i<k;i++) {
        cin >> str[i];
        str[i]+=str[i];
    }
    precomp();
    int l, r, mid;
    l=0; r=n;
    while (l<=r) {
        mid=(l+r)/2;
        if (check(mid)) l=mid+1;
        else r=mid-1;
    }
    cout << r << endl;
    return 0;
}

