#include <iostream>
#include <algorithm>
#include <unordered_map>
using namespace std;
const int MAXN=2e5+10;
const long long sys=27;
struct Systezatel {
    int sub[8];
    long long sum;
    long long val;
};
struct Special_sort {
    long long sum;
    long long val;
    int ind;
};
Systezatel comp[MAXN];
Special_sort sp[MAXN];
unordered_map <long long, int> um;
char str[12];
bool cmp(Special_sort a, Special_sort b) {
    if (a.sum!=b.sum) return a.sum>b.sum;
    return a.val<b.val;
}
long long geth() {
    long long res=0;
    for (int i=0;i<10;i++) {
        res=(res*sys+(long long)(str[i]-'a'));
    }
    return res;
}
string revise_str(long long h) {
    string ans;
    while (h>0) {
        ans+='a'+h%27;
        h/=27;
    }
    for (int i=0;i<ans.size()/2;i++) swap(ans[i],ans[ans.size()-i-1]);
    return ans;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;

    for (int i=0;i<n;i++) {
        cin >> str;
        comp[i].val=geth();
        um[comp[i].val]=i;
    }
    int curs;
    for (int i=0;i<m;i++) {
        cin >> str;
        int ind=um[geth()];
        for (int j=0;j<k;j++) {
            cin >> curs;
            comp[ind].sub[j]=max(comp[ind].sub[j],curs);
        }
    }
    for (int i=0;i<n;i++) {
        sp[i].sum=0;
        sp[i].ind=i;
        sp[i].val=comp[i].val;
        for (int j=0;j<k;j++) sp[i].sum+=comp[i].sub[j];
    }
    sort(sp,sp+n,cmp);
    for (int j=0;j<n;j++) {
        int i=sp[j].ind;
        cout << revise_str(comp[i].val) << ' ' << sp[j].sum << ' ';
        for (int p=0;p<k;p++) cout << comp[i].sub[p] << ' ';
        cout << endl;
    }
    return 0;
}
/**
5 6 2
benq
tourist
radewooszz
maroonrk
sorting
sorting 40 10
tourist 50 50
maroonrk 20 30
sorting 20 150
tourist 150 0
radewooszz 25 25
**/
