#include <iostream>
#include <vector>
#include <stack>
using namespace std;
const int MAXN=1e5+10;
const int MAXM=1e6+10;
struct smth {
    int a, b;
    int ind, next, prev, cur;
};
vector <pair <int,int> > v[2][MAXN];
vector <pair <int,int> > ver[MAXN];
stack <int> st;
int cnt[MAXN], comp[MAXN], curbr;
smth spisk[MAXN];
int used[MAXM], gr[MAXM], last[MAXN];
int n, m;
void add_edge(int a, int b, int ind, int fl) {
    v[fl][a].push_back({b,ind});
    v[fl][b].push_back({a,ind});
    if (fl==0) {
        ver[a].push_back({b,ind});
        ver[b].push_back({a,ind});
    }
}
void dfs (int x) {
    comp[x]=curbr;
    for (auto i:v[1][x]) {
        if (comp[i.first]!=0) continue;
        dfs(i.first);
    }
}
void transform_graph() {
    for (int i=1;i<=n;i++) {
        for (auto j:v[0][i]) {
            gr[j.second]=1;
        }
        for (auto j:v[1][i]) {
            gr[j.second]=2;
        }
    }
}
void euler(int x) {
    if (x==-1) return;
    used[spisk[x].ind]++;
    if (used[spisk[x].ind]==gr[spisk[x].ind]) {
        spisk[x].cur=spisk[x].next;
        if (spisk[x].prev!=-1) spisk[spisk[x].prev].next=spisk[x].next;
    }
    euler(spisk[last[spisk[x].b]].cur);
    st.push(spisk[x].ind);
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int a, b, fl;
    cin >> n >> m;
    for (int i=1;i<=n;i++) last[i]=-1;
    for (int i=1;i<=2*m;i++) spisk[i].prev=-1;
    for (int i=1;i<=m;i++) {
        cin >> a >> b >> fl;
        add_edge(a,b,i,0);
        if (fl==2) {
            add_edge(a,b,i,1);
        }
        smth cur;
        cur.a=a; cur.b=b; cur.ind=i; cur.cur=i*2;
        cur.next=last[a];
        spisk[last[a]].prev=i*2;
        spisk[i*2]=cur;
        swap(cur.a,cur.b);
        cur.next=last[b]; cur.cur=i*2+1;
        spisk[i*2+1]=cur;
        spisk[last[a]].prev=i*2+1;
        last[a]=i*2;
        last[b]=i*2+1;
    }
    curbr=1;
    for (int i=1;i<=n;i++) {
        if (comp[i]==0) {
            comp[i]=curbr;
            dfs(i);
            curbr++;
        }
    }
    for (int i=1;i<=n;i++) {
        if (v[0][i].size()%2==1) cnt[comp[i]]++;
    }
    bool one=false;
    int c=0;
    for (int i=1;i<curbr;i++) {
        if (cnt[i]%2==1) {
            c++;
            if (i==1) one=true;
        }
    }
    if (!(c==0 || (c==2 && one))) {
        cout << -1 << endl;
        return 0;
    }
    transform_graph();
    euler(last[1]);
    cout << st.size() << endl;
    while (!st.empty()) {
        cout << st.top() << ' ';
        st.pop();
    }
    return 0;
}
/**
10 18
1 10 1
7 9 2
2 6 1
3 7 1
3 8 1
9 2 2
2 8 2
4 2 1
4 6 1
6 8 1
3 6 1
1 9 1
4 9 1
10 7 2
7 5 2
5 3 1
4 7 1
10 5 1
**/
