#include <iostream>
#include <string>

#define endl '\n'

using namespace std;

const int MAXN = 1e3 + 3;
int dp[MAXN][MAXN];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    string a, b;
    cin >> a >> b;

    n = 2 * n - 1;

    a += a;
    a[n] = '\0';

    b += b;
    b[n] = '\0';

    int res = 0;
    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            if (a[i - 1] == b[j - 1])
            {
                dp[i][j] = dp[i - 1][j - 1] + 1;
                res = max(res, dp[i][j]);
            }
        }
    }

    cout << res << endl;

    return 0;
}
