#include<iostream>
#include<map>
#include<algorithm>
using namespace std;

int broiUchastnici;
int broiSubmiti;
int broiPodzad;

string ime[250010];
int tochkiPodzad[250010][10];

map<string, int> imeIndex;

int totalUch[250010];

struct DanniZaUchastnik{
    int index;
    int tochki;
};

DanniZaUchastnik uchastnici[250010];

int daiIndex(string otIme){
    return imeIndex[otIme];
}

bool koiEpoNapred(DanniZaUchastnik a, DanniZaUchastnik b){
    if(a.tochki > b.tochki){
        return true;
    }
    if(a.tochki < b.tochki){
        return false;
    }
    return ime[a.index] < ime[b.index];
}

int main(){

    cin>>broiUchastnici>>broiSubmiti>>broiPodzad;

    for(int i = 0; i < broiUchastnici; i++){
        cin>>ime[i];
        imeIndex[ime[i]] = i;
    }

    for(int t = 0; t < broiSubmiti; t++){
        string uchastnik;

        cin>>uchastnik;

        int indexUch = daiIndex(uchastnik);

        for(int i = 0; i < broiPodzad; i++){
            int tukaTochki;
            cin>>tukaTochki;

            if(tukaTochki > tochkiPodzad[indexUch][i]){
                totalUch[indexUch] += tukaTochki - tochkiPodzad[indexUch][i];
                tochkiPodzad[indexUch][i] = tukaTochki;
            }
        }

    }

    /*
    for(int i = 0; i < broiUchastnici; i++){
        cout<<ime[i]<<" "<<totalUch[i]<<" ";
        for(int j = 0; j < broiPodzad; j++){
            cout<<tochkiPodzad[i][j]<<" ";
        }
        cout<<endl;
    }
    */

    for(int i = 0; i < broiUchastnici; i++){
        uchastnici[i] = {i, totalUch[i]};
    }

    sort(uchastnici, uchastnici + broiUchastnici, koiEpoNapred);

    for(int i = 0; i < broiUchastnici; i++){
        cout<<ime[uchastnici[i].index]<<" "<<uchastnici[i].tochki<<" ";
        for(int j = 0; j < broiPodzad; j++){
            cout<<tochkiPodzad[uchastnici[i].index][j]<<" ";
        }
        cout<<endl;
    }

    return 0;
}
