#include <iostream>
#include <cstring>
#include <string>
#include <algorithm>
#define MAX_N 200005
#define MAX_K 11
using namespace std;

int table[2][MAX_N];
string words[MAX_K];
int n, k;

string maxcommon(string word1, string word2)
{
    int index=0;
    int pindex=1;
    int s=word1.size();
    int cmax=0;
    int cind=0;
    fill_n(table[index], 2*n+1, 0);

    for(int i=0; i<2*n; i++)
    {
        index=(index+1)%2;
        pindex=(pindex+1)%2;
        for(int j=0; j<s; j++)
        {
            if(word1[j]==word2[i])
            {
                table[index][j+1]=table[pindex][j]+1;
                if(table[index][j+1]>cmax)
                {
                    cmax=table[index][j+1];
                    cind=j;
                }
            }
            else
            {
                table[index][j+1]=0;
            }
        }
        /*for(int j=0; j<s; j++)
        {
            cout << table[index][j+1] << " ";
        }
        cout << endl;*/
    }
    //cout << cmax << endl;
    if(cmax==0)
    {
        return "";
    }
    cind=cind-cmax+1;
    return word1.substr(cind, cmax);
}

int main()
{
    cin >> n >> k;
    for(int i=0; i<k; i++)
    {
        cin >> words[i];
        words[i]+=words[i];
    }

    string common;

    if(words[0].compare(words[1])==0)
    {
        common=words[0];
    }

    common=maxcommon(words[0], words[1]);

    for(int i=2; i<k; i++)
    {
        //cout << common << words[i] << endl;
        common=maxcommon(common, words[i]);
        if(common=="")
        {
            break;
        }
    }

    cout << common.size();


    return 0;
}
