#include<iostream>
#include<map>
#include<vector>
#include<algorithm>

using namespace std;

typedef long long ll;

struct ra{
	string s;
	vector<int> c;
	ll t;
};

int n,m,k;
map<string,int> data;
ra a[250000];

bool comp(ra x,ra y)
{
	if(x.t>y.t) return true;
	if(x.t<y.t) return false;
	
	for(int i=0;i<min(x.s.length(),y.s.length());i++)
		if(x.s[i]<y.s[i]) return true;
		else if(x.s[i]>y.s[i]) return true;
	
	if(x.s.length()<y.s.length()) return true;
	return false;
}

int main()
{
	scanf("%d%d%d",&n,&m,&k);
	for(int i=0;i<n;i++)
	{
		string s;
		cin>>s;
		a[i].s=s;
		data.insert(make_pair(s,i));
		for(int j=0;j<k;j++)
			a[i].c.push_back(0);
		a[i].t=0;
	}
	for(int i=0;i<m;i++)
	{
		string s;
		int x;
		ll cc=0;
		cin>>s;
		int id=data[s];

		for(int j=0;j<k;j++)
		{
			scanf("%d",&x);
			a[id].c[j]=max(a[id].c[j],x);
			cc+=a[id].c[j];
		}
		a[id].t=cc;
	}
	
	sort(a,a+n,comp);
	
	for(int i=0;i<n;i++)
	{
		cout<<a[i].s<<" "<<a[i].t<<" ";
		for(int j=0;j<k;j++)
			printf("%d ",a[i].c[j]);
		printf("\n");
	}
}