#include<bits/stdc++.h>
#define fr first
#define sc second
#define pb push_back
#define de(x) cout << #x << " = " << x << endl;
#define all(A) A.begin(), A.end()
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXM = 2e6 + 6;

int N, M, mark[MAXM], T = 0;
matrix<pair<int, int>> G;
vector<int> path;

void dfs(int u){
    /// de(u);
    while(!G[u].empty()){
        int v = G[u].back().fr, i = G[u].back().sc;
        G[u].pop_back();
        if(mark[i]) continue;
        mark[i] = true;
        dfs(v);
    }
    path.pb(u);
}

int main(){
    cin >> N >> M;
    G = matrix<pair<int, int>>(N + 1);
    for(int i = 0; i < M; i ++){
        int u, v, t; cin >> u >> v >> t;
        for(int j = 0; j <= t; j ++){
            G[u].pb({v, T});
            G[v].pb({u, T});
            ++ T;
        }
    }
    vector<int> odd;
    for(int u = 1; u <= N; u ++){
        if(G[u].size() % 2 == 1){
            odd.pb(u);
        }
    }
    if(odd.size()){
        cout << "-1\n";
        return 0;
    }
    dfs(1);
    reverse(all(path));
    cout << path.size() << endl;
    for(auto x : path) cout << x << " "; cout << endl;
}
