#include<bits/stdc++.h>
#define pb push_back
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXM = 1e6 + 6;

int N, M, dep[MAXM];
matrix<pair<int, int>> G;
vector<int> path;

void dfs(int u = 1, int p = 1, int d = 1){
    dep[u] = d;
    for(auto [v, i] : G[u]){
        if(v == p) continue;
        if(dep[v] == 0){
            path.pb(i + 1);
            dfs(v, u, d + 1);
            path.pb(i + 1);
        }
        else if(dep[u] > dep[v]){
            path.pb(i + 1);
            path.pb(i + 1);
        }
    }
}

int main(){
    cin >> N >> M;
    G = matrix<pair<int, int>>(N + 1);
    for(int i = 0; i < M; i ++){
        int u, v, t; cin >> u >> v >> t;
        G[u].pb({v, i});
        G[v].pb({u, i});
    }
    dfs();
    cout << path.size() << endl;
    for(auto x : path) cout << x << " "; cout << endl;
}
