#include<bits/stdc++.h>
#define pb push_back
#define fr first
#define sc second
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXN = 2e5 + 5;

int N, M, depth[MAXN];
matrix<pair<int, int>> G;

void dfs(int u = 1, int p = 1, int d = 1){
    depth[u] = d;
    for(auto [v, i] : G[u]){
        if(v == p) continue;
        if(depth[v] == 0){
            cout << i << " ";
            dfs(v, u, d + 1);
            cout << i << " ";
        }
        else if(depth[u] > depth[v]){
            cout << i << " " << i << " ";
        }
    }
}

int main(){
    cin >> N >> M;
    G = matrix<pair<int, int>>(N + 1);
    for(int i = 1; i <= M; i ++){
        int u, v, t; cin >> u >> v >> t;
        G[u].pb({v, i});
        G[v].pb({u, i});
    }
    cout << 2 * M << endl;
    dfs();
    cout << endl;
}
