#include<bits/stdc++.h>
using namespace std;
#define ll long long
const int MAXK=12;
const int MAXN=2e5+6;
const ll base1=31;
const ll base2=37;
const ll mod1=1e9+7;
const ll mod2=1e9+9;
string s[MAXK];
ll pw1[MAXN],pw2[MAXN];
ll pw1r[MAXN],pw2r[MAXN];
int n,k;
ll fastpow(ll x,ll p,ll m)
{
    if(p==0)return 1;
    if(p==1)return x;
    ll t=fastpow(x,p/2,m);
    t*=t;t%=m;
    if(p%2==1)
    {
        t*=x;
        t%=m;
    }
    return t;
}
struct my_hash
{
    ll val1;
    ll val2;
    void append_letter(char c)
    {
        val1=(val1*base1+c-'a'+1)%mod1;
        val2=(val2*base2+c-'a'+1)%mod2;
    }
    void shift(int x)
    {
        val1*=pw1[x];
        val1%=mod1;

        val2*=pw2[x];
        val2%=mod2;
    }
    void shift_reverse(int x)
    {
        val1*=pw1r[x];
        val1%=mod1;

        val2*=pw2r[x];
        val2%=mod2;
    }
    ll single_hash()
    {
        return val1+val2;
    }
};
my_hash pref_hash[MAXK][MAXN];
my_hash get_hash(int idx,int l,int r)
{
    my_hash ret=pref_hash[idx][r];
    my_hash aux=pref_hash[idx][l-1];
    aux.shift(r-l+1);
    //cout<<"1* "<< ret.single_hash()<<endl;
    ret.val1+=mod1-aux.val1;
    ret.val1%=mod1;
    ret.val2+=mod2-aux.val2;
    ret.val2%=mod2;
    //cout<<"1.5* "<<aux.single_hash()<<endl;
    //cout<<"2* "<< ret.single_hash()<<endl;
    ret.shift_reverse(r-l+1);

    //cout<<"3* "<< ret.single_hash()<<endl;
    return ret;
}
void precompute()
{
    pw1[0]=1;
    pw2[0]=1;
    pw1r[0]=fastpow(1,mod1-2,mod1);
    pw2r[0]=fastpow(1,mod2-2,mod2);
    for(int i=1;i<MAXN;i++)
    {
        pw1[i]=(pw1[i-1]*base1)%mod1;
        pw2[i]=(pw2[i-1]*base2)%mod2;
        pw1r[i]=fastpow(pw1[i],mod1-2,mod1);
        pw2r[i]=fastpow(pw2[i],mod2-2,mod2);
    }
}
unordered_set<int>ss;
unordered_map<int,int>mp;
bool ok(int len)
{
    mp.clear();
    for(int i=1;i<=k;i++)
    {
        ss.clear();
        for(int j=len;j<n+len;j++)
        {
            //cout<<i<<" "<<j<<" "<<len<<" "<<get_hash(i,j-len+1,j).single_hash()<<endl;
            ss.insert(get_hash(i,j-len+1,j).single_hash());
        }
        //cout<<"----------------\n";
        for(auto xd:ss)
        {
            //cout<<xd<<" ";
            mp[xd]++;
        }
        //cout<<endl;
    }
    //for(auto xd:mp)
    //{
    //    cout<<xd.first<<" : "<<xd.second<<endl;
    //}
    for(auto xd:mp)
    {
        if(xd.second==k)
        {
            //cout<<"===  "<<xd.first<<endl;
            return 1;
        }
    }
    return 0;
}
int main()
{
    cin>>n>>k;
    precompute();
    for(int i=1;i<=k;i++)
    {
        cin>>s[i];
        s[i]+=s[i];
        for(int j=1;j<=s[i].size();j++)
        {
            pref_hash[i][j]=pref_hash[i][j-1];
            pref_hash[i][j].append_letter(s[i][j-1]);
            //cout<<i<<" "<<j<<" "<<pref_hash[i][j].single_hash()<<endl;
        }
    }
    int low=1,high=n,ans=0;
    while(low<=high)
    {
        int mid=(low+high)/2;
        if(ok(mid))
        {
            ans=mid;
            low=mid+1;
        }
        else
        {
            high=mid-1;
        }
    }
    cout<<ans<<endl;
return 0;
}
