#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAX_N = 2e5+2;
string s[MAX_N];
int max_sz = 0;
int n,m,k;
struct st
{
    int idx;
    int namehash;
    int res[5];
    int sum;
} a[MAX_N];
bool cmp(st &a, st &b)
{
    if(a.sum == b.sum)
    {
        return a.idx < b.idx;
    }
    return a.sum > b.sum;
}
int base = 71;
int MOD = 1e9+7;
map<int,int> hashtoid;
map<int,string> idtoname;
map<string,int> nametohash;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m>>k;
    for(int i=0; i<n; i++)
    {
        cin>>s[i];
        max_sz = max(max_sz, (int)s[i].size());
    }
    for(int i=0; i<n; i++)
    {
        while(s[i].size() < max_sz)
        {
            s[i] = s[i]+'$';
        }
    }
    sort(s,s+n);
    for(int i=0; i<n; i++)
    {
        string temp = "";
        for(int j=0; j<max_sz; j++)
        {
            if(s[i][j] == '$') break;
            temp = temp + s[i][j];
        }
        s[i] = temp;
    }
    for(int i=0; i<n; i++)
    {
        int temp_hash = 0;
        for(int j=0; j<max_sz; j++)
        {
            temp_hash *= base;
            temp_hash += (s[i][j]-'a');
            temp_hash %= MOD;
        }
        hashtoid[temp_hash] = i;
        idtoname[i] = s[i];
        nametohash[s[i]] = temp_hash;
        a[i].idx = i;
        a[i].namehash = temp_hash;
    }
    string name;
    for(int i=0; i<m; i++)
    {
        cin>>name;
        int cur_hash = nametohash[name];
        int id = hashtoid[cur_hash];
        int new_val;
        for(int j=0; j<k; j++)
        {
            cin>>new_val;
            a[id].res[j] = max(a[id].res[j], new_val);
        }
    }
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<k; j++)
        {
            a[i].sum += a[i].res[j];
        }
    }
    sort(a,a+n,cmp);
    for(int i=0; i<n; i++)
    {
        cout<<idtoname[a[i].idx]<<" "<<a[i].sum<<" ";
        for(int j=0; j<k; j++)
        {
            cout<<a[i].res[j]<<" ";
        }
        cout<<endl;
    }
}

