#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAX_N = 1e5+2;
vector< pair<int,int> > adj[MAX_N];
int used[MAX_N];
int n,m,u0,v0,t0;
vector<int> path;
map<pair<int,int>,int> edge;
void dfs(int cur, int par)
{
    used[cur] = 1;
    path.push_back(cur);
    for(auto x: adj[cur])
    {
        if(used[x.first] == 0)
        {
            dfs(x.first, cur);
        }
    }
    path.push_back(par);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
    for(int i=1; i<=m; i++)
    {
        cin>>u0>>v0>>t0;
        edge[{u0,v0}] = i;
        edge[{v0,u0}] = i;
        adj[u0].push_back({v0,t0});
        adj[v0].push_back({u0,t0});
    }
    dfs(1,-1);
    cout<<path.size()-2<<endl;
    for(int i=1; i<path.size()-1; i++)
    {
        cout<<edge[{path[i-1],path[i]}]<<" ";
    }
    cout<<endl;
}
