#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAX_N = 1e6+10;
const int MAX_M = 1e6+10;
vector< pair<int,int> > adj[MAX_N];
int n,m,u0,v0,t0;
int br = 0;
int used[MAX_M];
stack<int> st1;
stack<int> st2;
map<pair<int,int>,vector<int>> ma;
map<pair<int,int>,int> p;
void dfs(int cur)
{
    for(auto x: adj[cur])
    {
        if(used[x.second] == 0)
        {
            used[x.second] = 1;
            st1.push(x.first);
            dfs(x.first);
        }
    }
    if(!st1.empty())
    {
        st2.push(st1.top());
        st1.pop();
    }
}
void euler_cycle(int s)
{
    st1.push(s);
    dfs(s);
    if(st2.size() != m+1)
    {
        cout<<-1<<endl;
        return;
    }
    cout<<m<<endl;
    int last = st2.top();
    st2.pop();
    while(!st2.empty())
    {
        int cur = st2.top();
        pair<int,int> tmp = {min(cur,last),max(cur,last)};
        cout<<ma[tmp][p[tmp]]<<" ";
        p[tmp]++;
        last = cur;
        st2.pop();
    }
    cout<<endl;
//
//    if(!ste2.empty()) ste2.pop();
//    if(ste2.size() != m)
//    {
//        cout<<-1<<endl;
//    }
//    else
//    {
//        cout<<m<<endl;
//        while(!ste2.empty())
//        {
//            cout<<ste2.top()<<" ";
//            ste2.pop();
//        }
//        cout<<endl;
//    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
    for(int i=1; i<=m; i++)
    {
        cin>>u0>>v0>>t0;
        if(u0 > v0) swap(u0,v0);
        ma[{u0,v0}].push_back(i);
        p[{u0,v0}] = 0;
        adj[u0].push_back({v0,i});
        adj[v0].push_back({u0,i});
    }
    for(int i=1; i<=n; i++)
    {
        if(adj[i].size()%2 == 1)
        {
            cout<<-1<<endl;
            return 0;
        }
    }
    euler_cycle(1);
}
/**
11 13
1 2 1
2 3 1
3 4 1
4 5 1
5 1 1
3 8 1
8 7 1
7 6 1
6 3 1
6 9 1
9 10 1
10 11 1
11 6 1

3 7
1 2 1
1 2 1
1 2 1
2 3 1
2 3 1
2 3 1
1 3 1

6 10
1 2 1
1 3 1
1 4 1
1 5 1
1 6 1
1 2 1
1 3 1
1 4 1
1 5 1
1 6 1


13 19
1 2 1
2 3 1
3 4 1
4 5 1
5 7 1
7 12 1
12 13 1
13 1 1
5 8 1
8 10 1
10 9 1
9 5 1
4 7 1
4 6 1
6 7 1
3 6 1
3 11 1
11 2 1
2 6 1
*/
