#include<bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")
using namespace std;
const short MAX_N = 1e5+10;
const short MAX_M = 1e6+10;
vector< pair<short,short> > adj[MAX_N];
short n,m,u0,v0,t0;
short br = 0;
short used[MAX_M];
stack<short> st1;
stack<short> ste1;
stack<short> st2;
stack<short> ste2;
void dfs(short cur)
{
    for(auto x: adj[cur])
    {
        if(used[x.second] == 0)
        {
            used[x.second] = 1;
            st1.push(x.first);
            ste1.push(x.second);
            dfs(x.first);
        }
    }
    st2.push(st1.top());
    ste2.push(ste1.top());
    st1.pop();
    ste1.pop();
}
void euler_cycle(short s)
{
    st1.push(s);
    ste1.push(0);
    dfs(s);
    if(!st2.empty()) ste2.pop();
    if(ste2.size() != m)
    {
        cout<<-1<<endl;
    }
    else
    {
        cout<<m<<endl;
        while(!ste2.empty())
        {
            cout<<ste2.top()<<" ";
            ste2.pop();
        }
        cout<<endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
    for(short i=1; i<=m; i++)
    {
        cin>>u0>>v0>>t0;
        adj[u0].push_back({v0,i});
        adj[v0].push_back({u0,i});
    }
    for(short i=1; i<=n; i++)
    {
        if(adj[i].size()%2 == 1)
        {
            cout<<-1<<endl;
            return 0;
        }
    }
    euler_cycle(1);
    return 0;
}
/**
11 13
1 2 1
2 3 1
3 4 1
4 5 1
5 1 1
3 8 1
8 7 1
7 6 1
6 3 1
6 9 1
9 10 1
10 11 1
11 6 1

3 7
1 2 1
1 2 1
1 2 1
2 3 1
2 3 1
2 3 1
1 3 1

6 10
1 2 1
1 3 1
1 4 1
1 5 1
1 6 1
1 2 1
1 3 1
1 4 1
1 5 1
1 6 1


13 19
1 2 1
2 3 1
3 4 1
4 5 1
5 7 1
7 12 1
12 13 1
13 1 1
5 8 1
8 10 1
10 9 1
9 5 1
4 7 1
4 6 1
6 7 1
3 6 1
3 11 1
11 2 1
2 6 1
*/
