#include<iostream>
#include<unordered_map>
#include<vector>
#include<tuple>
#include<algorithm>
using namespace std;

const int MAXN=3e5, MAXK=5;

unordered_map<string, int> nameIdx;
unordered_map<int, string> idxName;

int pts[MAXN][MAXK];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, k;
    cin >> n >> m >> k;

    for(int i=0; i<n; i++)
    {
        string s;
        cin >> s;

        nameIdx[s]=i;
        idxName[i]=s;

        for(int j=0; j<MAXK; j++)
        {
            pts[i][j]=0;
        }
    }

    for(int i=0; i<m; i++)
    {
        string s;
        cin >> s;

        int idx=nameIdx[s];

        for(int j=0; j<k; j++)
        {
            int x;
            cin >> x;

            pts[idx][j]=max(pts[idx][j], x);
        }
    }

    vector<tuple<int, string, vector<int> > > res;
    for(int i=0; i<n; i++)
    {
        int x=0;
        for(int j=0; j<MAXK; j++)
        {
            x+=pts[i][j];
        }

        string s=idxName[i];

        res.push_back({-x, s, {-pts[i][0], -pts[i][1], -pts[i][2], -pts[i][3], -pts[i][4]}});
    }
    sort(res.begin(), res.end());

    for(int i=0; i<n; i++)
    {
        cout << get<1>(res[i]) << " " << -get<0>(res[i]) << " ";
        for(int j=0; j<k; j++)
        {
            cout << -get<2>(res[i])[j] << " ";
        }
        cout << "\n";
    }

    return 0;
}
