#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int MAXM = 1000000;

int pos[MAXN + 5];
bool used1[MAXN + 5];
bool used2[MAXM + 5];
int cnt[MAXM + 5];
vector< pair<int, int> > G[MAXN + 5];
vector< pair<int, int> > cycles[MAXN + 5];

void print(int u)
{
    used1[u] = true;
    for (auto [v, t] : cycles[u])
    {
        cnt[t]++;
        cout << t << " ";
        if (!used1[v]) print(v);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= m; ++ i)
    {
        int u, v, t;
        cin >> u >> v >> t;
        G[u].push_back({v, i});
        G[v].push_back({u, i});
    }

    for (int i = 1; i <= n; ++ i)
    {
        if (G[i].size() % 2)
        {
            cout << -1 << endl;
            return 0;
        }
    }

    cout << m << endl;

    for (int i = 1; i <= n; ++ i)
    {
        int u = i;
        while (pos[u] < G[u].size() and used2[G[u][pos[u]].second]) pos[u]++;
        while (pos[u] < G[u].size())
        {
            int v = G[u][pos[u]].first, t = G[u][pos[u]].second;
            cycles[i].push_back(G[u][pos[u]]);
            used2[t] = true;
            u = v;
            while (pos[u] < G[u].size() and used2[G[u][pos[u]].second]) pos[u]++;
        }
    }

    print(1);
    cout << endl;
    
    for (int i = 1; i <= m; ++ i)
    {
        if (cnt[i] == 0) while (true) {}
    }

    return 0;
}
