#include <bits/stdc++.h>
#define llong long long
using namespace std;

const int maxn = 25e+4+4;

const llong p27[11] = {
    1, 27, 729, 19683,
    531441, 14348907,
    387420489, 10460353203,
    282429536481, 7625597484987,
    205891132094649
};

llong hashed[maxn], sums[maxn], vals[maxn][5];
vector<llong> indeces;
string names[maxn];
map<llong, llong> hash_to_ind;
llong n, m, k;

llong hfunc(const string& str)
{
    llong answer = 0, k = 0;
    for(llong i = str.size(); i > 0; i--)
    {
        answer += p27[k] * (llong)(str[i-1]-'a'+1);
        k++;
    }
    return answer;
}

int main()
{
    cin >> n >> m >> k;
    for(int i = 0; i < n; i++)
    {
        cin >> names[i];
        hashed[i] = hfunc(names[i]);
        hash_to_ind[hashed[i]] = i;

        indeces.emplace_back(i);
    }

    string sname; llong index, nval;
    for(int i = 0; i < m; i++)
    {
        cin >> sname; index = hash_to_ind[hfunc(sname)];
        for(int j = 0; j < k; j++)
        {
            cin >> nval;
            vals[index][j] = max(vals[index][j], nval);
        }
    }

    for(int i = 0; i < n; i++)
        for(int j = 0; j < k; j++)
            sums[i] += vals[i][j];

    sort(indeces.begin(), indeces.end(),
    [](llong l, llong r)
    {
        if(sums[l] > sums[r]) return true;
        if(sums[l] == sums[r] && hashed[l] < hashed[r]) return true;
        return false;
    }
    );

    for(int i = 0; i < n; i++)
    {
        index = indeces[i];
        cout << names[index] << " " << sums[index] << " ";
        for(int j = 0; j < k; j++)
            cout << vals[index][j] << " ";
        cout << endl;
    }
    return 0;
}
