#include <bits/stdc++.h>
#define endl "\n"
#define pii pair<int, int>
#define ff first
#define ss second
using namespace std;

const int maxn = 1e+5+5;
const int maxm = 2e+6+6;

bool check = false;

int n, m, ecount;
vector<int> nodes[maxn]; int deg[maxn]; int iter[maxn];
vector<pii> edges; bool used[maxm];
vector<int> true_index;

void input();
void solve();
vector<int> cycle;
void euler();


int main()
{
    input();
    euler();
    solve();
    return 0;
}

void input()
{
    // ios_base::sync_with_stdio(0);
    // cin.tie(0);
    ecount = 0;

    cin >> n >> m;
    int f, t, k;
    for(int i = 0; i < m; i++)
    {
        cin >> f >> t >> k;
        for(int j = 0; j < k; j++)
        {
            edges.emplace_back(f, t);
            true_index.emplace_back(i+1);
            nodes[f].emplace_back(ecount);
            nodes[t].emplace_back(ecount);
            deg[f]++, deg[t]++, ecount++;
        }
    }
}

void euler()
{
    stack<int> st;
    stack<int> edge_indeces;
    int prev = -1, edge;
    st.push(1);
    edge_indeces.push(-1);
    while(!st.empty())
    {
        int top = st.top();
        int edge_index = edge_indeces.top();

        // cout << top << endl;

        if(prev == top) return;
        prev = top;

        if(deg[top] == 0)
        {
            cycle.emplace_back(edge_index);
            st.pop();
            edge_indeces.pop();
            continue;
        }

        for(; iter[top] < nodes[top].size(); iter[top]++)
        {
            edge = nodes[top][iter[top]];

            if(used[edge]) continue;
            used[edge] = true;

            int other = (edges[edge].ff != top ? edges[edge].ff : edges[edge].ss);
            deg[top]--, deg[other]--;
            st.push(other); edge_indeces.push(edge);

            continue;
        }
    }
    check = true;
}

void solve()
{
    if(!check || cycle.size() <= 2)
    {
        cout << -1 << endl;
        return;
    }
    pii fedge = edges[cycle[0]];
    if(fedge.ff != 1 && fedge.ss != 1)
    {
        cout << -1 << endl;
        return;
    }
    cycle.pop_back();
    cout << cycle.size() << endl;
    for(int i = cycle.size()-1; i >= 0; i--)
    {
        cout << true_index[cycle[i]] << " ";
    }
    cout << endl;
}
