#include<iostream>
#include<math.h>
#include<algorithm>
#include<map>
#include <unordered_map>

using namespace std;

class Competitor
{
public:
    void Initialise()
    {
        for(int i = 0;i < 6;i++)
        {
            points[i] = 0;
        }
    }

    int totalPoints = 0;

    string name;

    int points[6];

    void SetPoints(int index, int p)
    {
        if(points[index] < p)
        {
            totalPoints -= points[index];

            points[index] = p;

            totalPoints += points[index];
        }
    }
};

bool Compare(Competitor a, Competitor b)
{
    if(a.totalPoints > b.totalPoints)
    {
        return true;
    }

    if(a.name < b.name)
    {
        return true;
    }

    return false;
}

unordered_map<string, Competitor> a;

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL);
    int n,m,k;

    cin>>n>>m>>k;

    Competitor cp[n];

    for(int i = 0;i < n;i++)
    {
        Competitor c;

        cin>>c.name;

        c.Initialise();

        cp[i] = c;

        a[c.name] = c;
    }

    for(int i = 0;i < m;i++)
    {
        string name;
        cin>>name;

        for(int j = 0;j < k;j++)
        {
            int newPoints;

            cin>>newPoints;
            a[name].SetPoints(j, newPoints);
        }
    }

    int index = 0;

    for(int i = 0;i < n;i++)
    {
        cp[i] = a[cp[i].name];
    }

    sort(cp, cp + n, Compare);

    for(int i = 0;i < n;i++)
    {
        cout<<cp[i].name<<" "<<cp[i].totalPoints;

        for(int j = 0;j < k;j++)
        {
            cout<<" "<<cp[i].points[j];
        }

        cout<<endl;
    }
}
