#include<bits/stdc++.h>
using namespace std;

const int maxn = 1e5+2;
int n, k, p[3*maxn], res, ans;
string s1, s2;

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> k ;
    cin >> s1 >> s2 ;
    s2 = s2 + s2;
}

void prefix()
{
    p[0] = 0;
    int i, len = s1.size();
    for (i=1; i<len; ++i)
    {
        int j = p[i-1];
        while (j > 0 && s1[i] != s1[j]) j = p[j-1];
        if (s1[i] == s1[j]) ++ j;
        p[i] = j;
    }
}

void solve(int pos)
{
    string s = "";
    int i;
    for (i=pos; i<n; ++i) s += s1[i];
    for (i=0; i<pos; ++i) s += s1[i];

    res = 0;
    memset(p, 0, sizeof(p));
    p[0] = 0;
    int j, len = n;
    for (i=1; i<len; ++i)
    {
        j = p[i-1];
        while (j > 0 && s1[i] != s1[j]) j = p[j-1];
        if (s1[i] == s1[j]) ++ j;
        p[i] = j;
    }
    p[len] = 0;
    s += '#';
    s += s2;

    len = 3*n+1;
    for (i=n+1; i<len; ++i)
    {
        int j = p[i-1];
        while (j > 0 && s[i] != s[j]) j = p[j-1];
        if (s[i] == s[j]) ++ j;
        p[i] = j;
        if (p[i] > res) res = p[i];
    }
}

void print()
{
    for (int i=0; i<n; ++i)
    {
        solve(i);
        if (res > ans) ans = res;
    }
    cout << ans << '\n' ;
}

int main()
{
    read();
    print();
    return 0;
}