#include<bits/stdc++.h>
using namespace std;
const int maxn = 100001;
const int maxk = 10;
int n,k;
int h[maxk][maxn];
int pw[maxn];
string s;

int base = 33;
int mod = 1e9 + 7;

void fill_array()
{
    pw[0] = 1;
    for( int i = 1; i <= n; i ++ )
    {
        pw[i] = pw[i-1] * base; /// mod ???
    }
}

void make_hash( int idx )
{
    //cout << s << endl;
    for( int i = 1; i <= n; i ++ )
    {
        h[idx][i] = ( h[idx][i-1] * base ) + s[i-1]; /// mod ???
    }
}

void read()
{
    cin >> n >> k;
    n = ( 2 * n ) - 1;
    fill_array();

    for( int i = 1; i <= k; i ++ )
    {
        cin >> s;
        s += s;
        make_hash(i);
    }
}

int check( int sub, int len )
{
    for( int i = 2; i <= k; i ++ )
    {
        int lamp = 0;

        for( int l = 1; l <= n; l ++ )
        {
            int r = l + len - 1;
            if( r > n ) break;

            int t = h[i][r] - ( h[i][l-1] * pw[len] ); /// mod ???

            if( t == sub )
            {
                lamp = 1;
                break;
            }
        }

        if( lamp == 0 ) return 0;
    }

    return 1;
}

void solve()
{
    int ans = 0;

    for( int i = 1; i <= n; i ++ )
    {
        for( int j = i; j <= n; j ++ )
        {
            int len = j - i + 1;
            if( len > n ) break;
            int sub = h[1][j] - ( h[1][i-1] * pw[len] ); /// mod ???
            int lamp = check(sub,len);

            if( lamp == 1 ) ans = max( ans , len );
            else break;
        }
    }

    cout << ans << endl;
}

int main()
{
    read();
    solve();
    return 0;
}

/*

5 2
fabcq
bcdda

*/
