#include<bits/stdc++.h>
using namespace std;
const long long maxn = 100001;
const long long maxk = 12;
long long n,k;
long long h[maxk][maxn];
long long pw[maxn];
string s;

long long base = 33;
long long mod = 1e9 + 7;

void fill_array()
{
    pw[0] = 1;
    for( long long i = 1; i <= n; i ++ )
    {
        pw[i] = pw[i-1] * base; /// mod ???
    }
}

void make_hash( long long idx )
{
    //cout << s << endl;
    for( long long i = 1; i <= n; i ++ )
    {
        h[idx][i] = ( h[idx][i-1] * base ) + s[i-1]; /// mod ???
    }
}

void read()
{
    cin >> n >> k;
    n = ( 2 * n ) - 1;
    fill_array();

    for( long long i = 1; i <= k; i ++ )
    {
        cin >> s;
        s += s;
        make_hash(i);
    }
}

long long check( long long sub, long long len )
{
    for( long long i = 2; i <= k; i ++ )
    {
        long long lamp = 0;

        for( long long l = 1; l <= n; l ++ )
        {
            long long r = l + len - 1;
            if( r > n ) break;

            long long t = h[i][r] - ( h[i][l-1] * pw[len] ); /// mod ???

            if( t == sub )
            {
                lamp = 1;
                break;
            }
        }

        if( lamp == 0 ) return 0;
    }

    return 1;
}

void solve()
{
    long long ans = 0;

    for( long long i = 1; i <= n; i ++ )
    {
        for( long long j = i; j <= n; j ++ )
        {
            long long len = j - i + 1;
            if( len > n ) break;
            long long sub = h[1][j] - ( h[1][i-1] * pw[len] ); /// mod ???
            long long lamp = check(sub,len);

            if( lamp == 1 ) ans = max( ans , len );
            else break;
        }
    }

    cout << ans << endl;
}

int main()
{
    read();
    solve();
    return 0;
}

/*

5 2
fabcq
bcdda

*/
