#include<bits/stdc++.h>
using namespace std;
const int maxn=(1<<18);
unordered_map<string,int>names;
unordered_map<int,string>idxes;
struct comp{
    int idx,mpoints;
    vector<int>subs;
    comp(){
        idx=-1;
        mpoints=-1;
    }
    comp(int _idx, int _mpoints, vector<int> _subs){
        idx=_idx;
        mpoints=_mpoints;
        subs=_subs;
    }
    void newsub(vector<int> _new){
        int points=0,k=_new.size();
        for(int i=0;i<k;++i){
            if(subs[i]<_new[i])
                subs[i]=_new[i];
            points+=subs[i];
        }
        mpoints=points;
    }
    void find_mpoints(){
        for(auto i:subs)
            mpoints+=i;
    }
    bool operator<(const comp &other)const{
        if(mpoints==other.mpoints){
            string s1=idxes[idx];
            string s2=idxes[other.idx];
            return s1<s2;
        }
        return mpoints<other.mpoints;
    }
    bool operator>(const comp &other)const{
        if(mpoints==other.mpoints){
            string s1=idxes[idx];
            string s2=idxes[other.idx];
            return s1<s2;
        }
        return mpoints>other.mpoints;
    }
};
int n,m,k;
comp a[maxn];
void read(){
    cin >> n >> m >> k;
    string s;
    vector<int>v;
    v.resize(k);
    for(int i=1;i<=n;++i){
        cin>>s;
        names[s]=i;
        idxes[i]=s;
        a[i]=comp(i,0,v);
    }
    for(int i=1;i<=m;++i){
        cin>>s;
        int idx=names[s],w;
        for(int sub=0;sub<k;++sub)
            cin>>v[sub];
        a[idx].newsub(v);
    }
}
bool cmp(comp c,comp d){
    return c>d;
}
void print(){
    /*for(int i=1;i<=n;++i)
        a[i].find_mpoints();*/
    sort(a+1,a+1+n,cmp);
    for(int i=1;i<=n;++i){
        string name=idxes[a[i].idx];
        cout<<name<<" "<<a[i].mpoints;
        for(int sub=0;sub<k;++sub)
            cout<<" "<<a[i].subs[sub];
        cout<<endl;
    }
}
int main()
{
    /*ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);*/
    read();
    print();
return 0;
}
/*
5 6 2
benq
tourist
radewoosh
maroonrk
sorting

sorting 40 10
tourist 50 50
maroonrk 20 30
sorting 20 150
tourist 150 0
radewoosh 25 25
*/
