#include <bits/stdc++.h>
using namespace std;

const long long base = 257, mod = 1000000007;
long long bases[100003];

int n, k;

long long hesh (string a) {
    long long h=0;
    for (int i=0; i < a.size(); i++) {
        h = (h*base + (long long)a[i])%mod;
    }
    return h;
}

bool check (string a, string b) {
    //cout << "now " << a << " " << b << endl;
    if (b.size() > a.size()) {return false;}
    long long h = hesh(b);
    //cout << b << ": " << h << endl;
    long long h1=0;
    for (int i=0; i < b.size(); i++) {
        h1 = (h1*base + (long long)a[i])%mod;
    }
    for (int i=b.size(); i < a.size(); i++) {
        //cout << h1 << endl;
        if (h1 == h) {return true;}
        h1 = (h1*base + (long long)a[i])%mod;
        h1 = (h1 + mod - ((long long)a[i-b.size()]*bases[b.size()])%mod)%mod;
        //cout << h1 << endl;
        if (h1 == h) {return true;}
    }
    return false;
}

string common (string a, string b) {
    string curr="", ans="";
    int maxi=-1;
    for (int i=0; i < a.size(); i++) {
        curr = "";
        for (int j=i; j <= i+n-1; j++) {
            curr += a[j];
            if (check(b, curr) == true) {
                if (maxi < j-i+1) {
                    maxi = j-i+1;
                    ans = curr;
                }
            }
            if (j == a.size()-1) {break;}
        }
    }
    return ans;
}

string a[10];
string answer="";

int main () {
ios_base::sync_with_stdio(false);
cin.tie(0); cout.tie(0);

cin >> n >> k;

bases[0]=1;
for (int i=1; i < 100003; i++) {
    bases[i] = (bases[i-1]*base)%mod;
}

//cout << int('a') << endl;
//cout << hesh ("ab") << endl;
//cout << check ("artbcdfthjfe", "bcdfgh") << endl;
//cout << common ("abc", "ab") << endl;

for (int i=0; i < k; i++) {
    cin >> a[i];
    a[i] = a[i] + a[i];
}

answer = a[0];

for (int i=1; i < k; i++) {
    answer = common (answer, a[i]);
}

//cout << answer << endl;
cout << answer.size() << endl;

return 0;
}