#include <bits/stdc++.h>
using namespace std;

const long long base1 = 257, base2 = 263, mod1 = 1000000009, mod2 = 1000000007;
long long bases1[100003], bases2[100003];

int n, k;

long long hesh1 (string a) {
    long long h=0;
    for (int i=0; i < a.size(); i++) {
        h = (h*base1 + (long long)a[i])%mod1;
    }
    return h;
}

long long hesh2 (string a) {
    long long h=0;
    for (int i=0; i < a.size(); i++) {
        h = (h*base2 + (long long)a[i])%mod2;
    }
    return h;
}

unordered_set <long long> heshove1 (string a) {
    unordered_set <long long> heshs;
    for (int i=0; i < a.size(); i++) {
        long long h1=0;
        for (int j=i; j < a.size(); j++) {
            h1 = (h1*base1 + (long long)a[j])%mod1;
            heshs.insert(h1);
        }
    }
    return heshs;
}

unordered_set <long long> heshove2 (string a) {
    unordered_set <long long> heshs;
    for (int i=0; i < a.size(); i++) {
        long long h1=0;
        for (int j=i; j < a.size(); j++) {
            h1 = (h1*base2 + (long long)a[j])%mod2;
            heshs.insert(h1);
        }
    }
    return heshs;
}

/**bool check (string a, string b) {
    //cout << "now " << a << " " << b << endl;
    if (b.size() > a.size()) {return false;}
    long long h11 = hesh1(b), h22 = hesh2(b);
    //cout << b << ": " << h << endl;
    long long h1=0, h2=0;
    for (int i=0; i < b.size(); i++) {
        h1 = (h1*base1 + (long long)a[i])%mod1;
    }
    for (int i=0; i < b.size(); i++) {
        h2 = (h2*base2 + (long long)a[i])%mod2;
    }
    for (int i=b.size(); i < a.size(); i++) {
        //cout << h1 << endl;
        if (h1 == h11 and h2 == h22) {return true;}
        h1 = (h1*base1 + (long long)a[i])%mod1;
        h2 = (h2*base2 + (long long)a[i])%mod2;
        h1 = (h1 + mod1 - ((long long)a[i-b.size()]*bases1[b.size()])%mod1)%mod1;
        h2 = (h2 + mod2 - ((long long)a[i-b.size()]*bases2[b.size()])%mod2)%mod2;
        //cout << h1 << endl;
        if (h11 == h1 and h22 == h2) {return true;}
    }
    return false;
}**/

/**string common (string a, string b) {
    unordered_set <long long> heshb1 = heshove1 (b);
    unordered_set <long long> heshb2 = heshove2 (b);
    string curr="", ans="";
    int maxi=-1;
    for (int i=0; i < a.size(); i++) {
        curr = "";
        long long currh1=0, currh2=0;
        for (int j=i; j <= i+n-1; j++) {
            curr += a[j];
            currh1 = (currh1*base1 + (long long)a[j])%mod1;
            currh2 = (currh2*base2 + (long long)a[j])%mod2;
            if (heshb1.find(currh1) != heshb1.end() and heshb2.find(currh2) != heshb2.end()) {
                if (maxi < j-i+1) {
                    maxi = j-i+1;
                    ans = curr;
                }
            }
            if (j == a.size()-1) {break;}
        }
    }
    return ans;
}**/

string a[10];
string answer="";

int main () {
ios_base::sync_with_stdio(false);
cin.tie(0); cout.tie(0);

cin >> n >> k;

bases1[0]=1;
for (int i=1; i < 100003; i++) {
    bases1[i] = (bases1[i-1]*base1)%mod1;
}
bases2[0]=1;
for (int i=1; i < 100003; i++) {
    bases2[i] = (bases2[i-1]*base2)%mod2;
}

//cout << int('a') << endl;
//cout << hesh ("ab") << endl;
//cout << check ("artbcdfthjfe", "bcdfgh") << endl;
//cout << common ("abc", "ab") << endl;

for (int i=0; i < k; i++) {
    cin >> a[i];
    a[i] = a[i] + a[i];
}

unordered_set <long long> heshb1[k];
unordered_set <long long> heshb2[k];

for (int i=1; i < k; i++) {
    heshb1[i] = heshove1(a[i]);
    heshb2[i] = heshove2(a[i]);
}
    string curr="", ans="";
    int maxi=-1;
    for (int i=0; i < a[0].size(); i++) {
        curr = "";
        long long currh1[k], currh2[k];
        for (int r=0; r < k; r++) {currh1[r] = 0; currh2[r] = 0;}
        for (int j=i; j <= i+n-1; j++) {
            curr += a[0][j];
            bool u=true;
            for (int o=1; o < k; o++) {
                currh1[o] = (currh1[o]*base1 + (long long)a[0][j])%mod1;
                currh2[o] = (currh2[o]*base2 + (long long)a[0][j])%mod2;
                if (heshb1[o].find(currh1[o]) != heshb1[o].end() and heshb2[o].find(currh2[o]) != heshb2[o].end()) {

                }
                else {
                    u = false;
                    break;
                }
            }
            if (u==true) {
                if (maxi < j-i+1) {
                    maxi = j-i+1;
                    ans = curr;
                }
            }
            if (j == a[0].size()-1) {break;}
        }
    }

cout << ans << endl;
cout << ans.size() << endl;

return 0;
}