#include <iostream>
#include <algorithm>
#include <unordered_map>
using namespace std;
const int MAXN=2e5+10;
const long long sys=27;
struct Systezatel {
    int sub[10];
    long long sum;
    long long val;
    string s;
};
Systezatel comp[MAXN];
unordered_map <long long, int> um;
string name;
bool cmp(Systezatel a, Systezatel b) {
    if (a.sum!=b.sum) return a.sum>b.sum;
    return a.val<b.val;
}
long long geth(string str) {
    long long res=0;
    for (int i=0;i<str.size();i++) {
        res=(res*sys+(long long)(str[i]-'a'));
    }
    return res;
}
string revise_str(long long h) {
    string ans;
    while (h>0) {
        ans+='a'+h%27;
        h/=27;
    }
    for (int i=0;i<ans.size()/2;i++) swap(ans[i],ans[ans.size()-i-1]);
    return ans;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;
    for (int i=0;i<n;i++) {
        cin >> name;
        comp[i].val=geth(name);
        um[comp[i].val]=i;
    }
    string str;
    int curs;
    for (int i=0;i<m;i++) {
        cin >> str;
        int ind=um[geth(str)];
        for (int j=0;j<k;j++) {
            cin >> curs;
            comp[ind].sub[j]=max(comp[ind].sub[j],curs);
        }
    }
    for (int i=0;i<n;i++) {
        comp[i].sum=0;
        for (int j=0;j<k;j++) comp[i].sum+=comp[i].sub[j];
    }
    sort(comp,comp+n,cmp);
    for (int i=0;i<n;i++) {
        cout << revise_str(comp[i].val) << ' ' << comp[i].sum << ' ';
        for (int j=0;j<k;j++) cout << comp[i].sub[j] << ' ';
        cout << endl;
    }
    return 0;
}
/**
5 6 2
benq
tourist
radewoosh
maroonrk
sorting
sorting 40 10
tourist 50 50
maroonrk 20 30
sorting 20 150
tourist 150 0
radewoosh 25 25
**/
