#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct person{
    string name;
    ll res[6];
    ll score=0;
};
bool comp(const person &a,const person &b){
    if(a.score==b.score){
        return a.name<b.name;
    }else{
        return a.score>b.score;
    }
}

const ll Size=5e5+1;
ll n,m,k;
string a[Size];
unordered_map<string,ll> name_to_res[6];
person ans[Size];

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m>>k;
    for(ll i=0;i<n;i++){
        cin>>a[i];
        for(ll j=0;j<k;j++)
            name_to_res[k][a[i]]=0;
    }
    for(ll i=0;i<m;i++){
        string curr_name;
        cin>>curr_name;
        for(ll j=0;j<k;j++){
            ll new_res;
            cin>>new_res;
            ll old_res=name_to_res[j][curr_name];
            name_to_res[j][curr_name]=max(old_res,new_res);
        }
    }
    for(ll i=0;i<n;i++){
        ans[i].name=a[i];
        for(ll j=0;j<k;j++){
            ll curr_best=name_to_res[j][a[i]];
            ans[i].score+=curr_best;
            ans[i].res[j]=curr_best;
        }
    }
    sort(ans,ans+n,comp);
    for(ll i=0;i<n;i++){
        cout<<ans[i].name<<" "<<ans[i].score<<" ";
        for(ll j=0;j<k;j++){
            cout<<ans[i].res[j]<<" ";
        }
        cout<<endl;
    }
    return 0;
}
/*
5 6 2
benq
tourist
radewoosh
maroonrk
sorting
sorting 40 10
tourist 50 50
maroonrk 20 30
sorting 20 150
tourist 150 0
radewoosh 25 25
*/
