#include <iostream>
#include <string>

#define endl '\n'

using namespace std;

const int MAXN = 1e3 + 3;
const int MAXK = 13;

string s[MAXK];
int dp[MAXN][MAXN];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    n = 2 * n - 1;

    for (int i = 0; i < k; ++i)
    {
        cin >> s[i];

        s[i] += s[i];
        s[n] = '\0';
    }

    for (int a = 1; a < k; ++a)
    {
        // string s1 = s[a - 1];
        // string s2 = s[a];

        for (int i = 1; i <= n; ++i)
        {
            for (int j = 1; j <= n; ++j)
            {
                if (s1[i - 1] == s2[j - 1])
                {
                    dp[i][j] = dp[i - 1][j - 1] + 1;
                }
                else
                {
                    dp[i][j] = 0;
                }
            }
        }
    }

    int res = 0;
    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            res = max(res, dp[i][j]);
        }
    }

    cout << res << endl;

    return 0;
}
