#include<iostream>
#include<vector>
using namespace std;

int broiGari;
int broiLinii;

struct DanniZaSaseda{
    int koiE;
    int nomerLiniq;
};

vector<DanniZaSaseda> sasedstvo[100010];

int chetnost[100010];

int liniqTip[1000010];

int broiMinati;
int patiMinata[1000010];

vector<int> pat;

bool mojeLiDaSePolzva(int koqLiniq){
    //cout<<"proverqvame liniq "<<koqLiniq<<" i tq ";
    if(patiMinata[koqLiniq] == 0){
        //cout<<"moje dase polzva"<<endl;
        return true;
    }
    if(patiMinata[koqLiniq] == 1 && liniqTip[koqLiniq] == 2){
        //cout<<"moje da se polzva"<<endl;
        return true;
    }
    //cout<<"ne moje da se polzva zashtoto e zaeta "<<patiMinata[koqLiniq]<<" pati"<<endl;
    return false;
}

bool dfs(int segashenVrah){
    if(segashenVrah == 1 && broiMinati == broiLinii){
        return true;
    }

    //cout<<"sega sam vav vrah "<<segashenVrah<<endl;

    bool stavaLi = false;

    for(int i = 0; i < (int)sasedstvo[segashenVrah].size(); i++){
        if(mojeLiDaSePolzva(sasedstvo[segashenVrah][i].nomerLiniq) == true){
            patiMinata[sasedstvo[segashenVrah][i].nomerLiniq]++;
            if(patiMinata[sasedstvo[segashenVrah][i].nomerLiniq] == 1){
                broiMinati++;
            }
            //cout<<"puskam se po liniq "<<sasedstvo[segashenVrah][i].nomerLiniq;
            //cout<<" koqto stava minata "<<patiMinata[sasedstvo[segashenVrah][i].nomerLiniq]<<endl;
            bool sega = dfs(sasedstvo[segashenVrah][i].koiE);
            //cout<<"otnovo sam vav vrah "<<segashenVrah<<endl;

            patiMinata[sasedstvo[segashenVrah][i].nomerLiniq]--;
            if(patiMinata[sasedstvo[segashenVrah][i].nomerLiniq] == 0){
                broiMinati--;
            }

            if(sega == true){
                stavaLi = true;
                pat.push_back(sasedstvo[segashenVrah][i].nomerLiniq);
                break;
            }
        }
    }

    //cout<<"ot tuka nqma izhod"<<endl;
    return stavaLi;
}

int main(){

    cin>>broiGari>>broiLinii;

    for(int i = 0; i < broiLinii; i++){
        int otKade;
        int doKade;
        int tip;

        cin>>otKade>>doKade>>tip;

        sasedstvo[otKade].push_back({doKade, i});
        sasedstvo[doKade].push_back({otKade, i});

        chetnost[otKade]++;
        chetnost[doKade]++;

        liniqTip[i] = tip;
    }

    bool okLiE = true;

    for(int i = 1; i <= broiGari; i++){
        if(chetnost[i]%2 == 1){
            okLiE = false;
        }
    }

    if(okLiE == true){
        cout<<1<<endl;
    }else{
        cout<<0<<endl;
    }

    /*
    dfs(1);

    if(pat.size() == 0){
        cout<<-1<<endl;
    }else{
        cout<<pat.size()<<endl;
        for(int i = 0; i < (int)pat.size(); i++){
            cout<<pat[i] + 1<<" ";
        }
        cout<<endl;
    }
    */

    return 0;
}
