#include <iostream>
#include <string>
#include <algorithm>
#define MAX_N 200005
#define MAX_K 11
using namespace std;

int currres[MAX_N];
int currmax[MAX_N];
int table[2][MAX_N];
string words[MAX_K];
int n, k;

void maxcommon(string word1, string word2)
{
    int index=0;
    int p=1;
    fill_n(table[index], 2*n+1, 0);
    fill_n(currmax, 2*n+1, 0);

    for(int i=0; i<2*n; i++)
    {
        index=(index+1)%2;
        p=(p+1)%2;
        for(int j=0; j<2*n; j++)
        {
            if(word1[i]==word2[j])
            {
                table[index][j+1]=table[p][j]+1;
                if(table[index][j+1]>n)
                {
                    table[index][j+1]=n;
                }
                if(table[index][j+1]>currmax[j+1])
                {
                    currmax[j+1]=table[index][j+1];
                }
            }
            else
            {
                table[index][j+1]=0;
            }
        }
        /*for(int j=0; j<2*n; j++)
        {
            cout << table[index][j+1] << " ";
        }
        cout << endl;*/
    }
}

int main()
{
    cin >> n >> k;

    for(int i=0; i<k; i++)
    {
        cin >> words[i];
        words[i]+=words[i];
    }
    maxcommon(words[1], words[0]);
    for(int i=0; i<2*n+1; i++)
    {
        currres[i]=currmax[i];
    }
    for(int i=2; i<k; i++)
    {
        //cout << "*************" << endl;
        maxcommon(words[i], words[0]);
        for(int j=0; j<2*n+1; j++)
        {
            currres[j]=min(currmax[j], currres[j]);
        }
        //cout << endl;
    }

    int maxi=0;

    for(int i=0; i<2*n+1; i++)
    {
        if(currres[i]>maxi)
        {
            maxi=currres[i];
        }
    }

    cout << maxi;



    return 0;
}
