#include <iostream>
#include <unordered_map>
#include <map>
#include <algorithm>
#include <string>
#include <cstring>
#define MAX_N 250003
using namespace std;

unordered_map <string, int> sustezateli;

struct sustezatel
{
    string ime;
    long long result[6];
};

sustezatel cont[MAX_N];

bool comp(sustezatel s1, sustezatel s2)
{
    if(s1.result[0]>s2.result[0])
    {
        return true;
    }
    else if(s1.result[0]==s2.result[0] && s2.ime.compare(s1.ime)>0)
    {
        return true;
    }
    return false;
}

int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    long long points[k+1];
    int index;
    string name;

    for(int i=0; i<n; i++)
    {
        cin >> name;
        sustezateli[name]=i;
        cont[i].ime=name;
    }

    for(int i=0; i<m; i++)
    {
        cin >> name;
        for(int j=1; j<=k; j++)
        {
            cin >> points[j];
        }
        index=sustezateli[name];
        for(int j=1; j<=k; j++)
        {
            if(points[j]>cont[index].result[j])
            {
                cont[index].result[0]+=(points[j]-cont[index].result[j]);
                cont[index].result[j]=points[j];
            }
        }
    }


    sort(cont, cont+n, comp);

    for(int i=0; i<n; i++)
    {
        cout << cont[i].ime << " ";
        for(int j=0; j<=k; j++)
        {
            cout << cont[i].result[j] << " ";
        }
        cout << endl;
    }







    return 0;
}



