#include <bits/stdc++.h>
using namespace std;

vector<pair<string, int>> v;

class Student
{
    public:
        int index;
        string name;
        int sum;
        Student()
        {

        }
        Student(int i, string n, int s)
        {
            index = i;
            name = n;
            sum = s;
        }
        void print()
        {
            cout << name << " " << sum;
        }
};

int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    int arr[n][k]; // [student][subproblem] = points
    Student stud[n];
    for(int i = 0; i < n; i++)
    {
        string s;
        cin >> s;
        v.push_back({s, i});
        for(int j = 0; j < k; j++)
        {
            arr[i][j] = 0;
        }
    }
    for(int i = 0; i < m; i++)
    {
        string s;
        cin >> s;
        int index = -1;
        for(int j = 0; j < n; j++)
        {
            if(v[j].first != s)
                continue;
            index = j;
            break;
        }
        for(int j = 0; j < k; j++)
        {
            int res;
            cin >> res;
            arr[index][j] = max(arr[index][j], res);
        }
    }
    for(int i = 0; i < n; i++)
    {
        int sum = 0;
        for(int j = 0; j < k; j++)
        {
            sum += arr[i][j];
        }
        Student s(i, v[i].first, sum);
        stud[i] = s;
    }
    sort(stud, stud + n, [](Student s1, Student s2) {
        if(s1.sum < s2.sum)
            return false;
        else if(s1.sum == s2.sum)
        {
            return s1.name.compare(s2.name)<0?true:false;
        }
        return true;
    });
    for(int i = 0; i < n; i++)
    {
        stud[i].print();
        for(int j = 0; j < k; j++)
        {
            cout << " " << arr[stud[i].index][j];
        }
        cout << endl;
    }
    return 0;
}
