#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5;
const int MAXM = 1e6;
vector<pair<int, int>> graph[MAXN+1];
bool visited[MAXN];
int n, m;
int cnt = 1;

vector<int> q;
void print()
{
    cout << cnt << endl;
    for(auto a = q.begin(); a != q.end(); a++)
    {
        cout << *a << " ";
    }
    cout << endl;
    exit(0);
}
void dfs(int vertex)
{
    if(cnt < n && vertex == 1 && cnt != 1)
        return;
    if(cnt == n && vertex == 1)
    {
        print();
        return;
    }
    for(int i = 0; i < graph[vertex].size(); i++)
    {
        if(!visited[graph[vertex][i].first])
        {
            visited[graph[vertex][i].first] = true;
            q.push_back(graph[vertex][i].second);
            cnt++;
            dfs(graph[vertex][i].first);
            visited[graph[vertex][i].first] = false;
            q.pop_back();
            cnt--;
        }
    }
}

int main()
{
    cin >> n >> m;
    for(int i = 1; i <= n; i++) {
        visited[i] = false;
    }
    for(int i = 1; i <= m; i++)
    {
        int a, b, k;
        cin >> a >> b >> k;
        graph[a].push_back({b, i});
        graph[b].push_back({a, i});
    }
    dfs(1);
}
