#include<bits/stdc++.h>
#define ll long long
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

const ll MOD = 1e9 + 7;
const ll BASE = 37;
const int MAXN = 2e5 + 5;
const int MAXK = 11;

ll N, K, pows[MAXN + 5], hashes[MAXK][MAXN];

void init(){
    pows[0] = 1;
    for(int i = 1; i <= MAXN; i ++) pows[i] = (pows[i - 1] * BASE) % MOD;
    /// for(int i = 0; i < 10; i ++) cout << pows[i] << " "; cout << endl;
}

bool can(int len){
    /// de(len);
    map<int, int> mp;
    for(int l = 0, r = len - 1; r < 2 * N; l ++, r ++){
        /// cout << "(l, r) = " << l << ", " << r << endl;
        for(int i = 0; i < K; i ++){
            ll got = (pows[MAXN - l] * (hashes[i][r] - (l ? hashes[i][l - 1] : 0) + MOD) % MOD) % MOD;
            /// cout << i << ": " << got << endl;
            mp[got] |= (1 << i);
            if(mp[got] == (1 << K) - 1) return true;
        }
    }
    return false;
}

int main(){
    init();
    cin >> N >> K;
    for(int i = 0; i < K; i ++){
        string t; cin >> t;
        t = t + t;
        for(int j = 0; j < 2 * N; j ++){
            hashes[i][j] = ((j ? hashes[i][j - 1] : 0) + (pows[j] * (t[j] - 'a' + 1)) % MOD) % MOD;
        }
    }
    int l = 1, r = N, ans = 0;
    while(l <= r){
        int m = (l + r) / 2;
        if(can(m)){
            ans = m;
            l = m + 1;
        }
        else{
            r = m - 1;
        }
    }
    cout << ans << endl;
}
