#include<bits/stdc++.h>
#define pb push_back
using namespace std;

template<class T> using matrix = vector<vector<T>>;

int N, M, lim[20];
matrix<pair<int, int>> G;
map<pair<int, vector<int>>, vector<int>> mp;

vector<int> dfs(int u, vector<int> used){
    if(mp.count({u, used})) return mp[{u, used}];
    for(auto [v, i] : G[u]){
        if(used[i] < lim[i]){
            used[i] ++;
            auto tmp = dfs(v, used);
            if(tmp[0] != -1){
                tmp.insert(tmp.begin(), i);
                return mp[{u, used}] = tmp;
            }
        }
    }
    return mp[{u, used}] = {-1};
}

int main(){
    cin >> N >> M;
    G = matrix<pair<int, int>>(N + 1);
    for(int i = 0; i < M; i ++){
        int u, v, t; cin >> u >> v >> t;
        G[u].pb({v, i});
        G[v].pb({u, i});
        lim[i] = t + 1;
    }
    vector<int> used(M);
    auto ans = dfs(1, used);
    if(ans[0] == -1) cout << "-1\n";
    else{
        cout << ans.size() << endl;
        for(auto x : ans) cout << x << " "; cout << endl;
    }
}
