#include<bits/stdc++.h>
#define pb push_back
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const vector<int> EMPTY = {-1};

int N, M, lim[20];
matrix<pair<int, int>> G;
map<pair<int, vector<int>>, vector<int>> mp;

vector<int> dfs(int u, vector<int> used){
    /**
    de(u);
    for(auto x : used) cout << x << " "; cout << endl;
    cin.get();
    */

    bool flag = (u == 1);
    for(auto x : used) flag &= x;
    /// cout << u << " & " << flag << endl;
    if(u == 1 && flag) return vector<int>();

    if(mp.count({u, used})) return mp[{u, used}];
    for(auto [v, i] : G[u]){
        if(used[i] < lim[i]){
            used[i] ++;
            auto tmp = dfs(v, used);
            if(tmp != EMPTY){
                tmp.insert(tmp.begin(), i);
                return mp[{u, used}] = tmp;
            }
            used[i] --;
        }
    }
    return mp[{u, used}] = EMPTY;
}

int main(){
    cin >> N >> M;
    G = matrix<pair<int, int>>(N + 1);
    for(int i = 0; i < M; i ++){
        int u, v, t; cin >> u >> v >> t;
        G[u].pb({v, i});
        G[v].pb({u, i});
        lim[i] = t;
    }
    vector<int> used(M);
    auto ans = dfs(1, used);
    if(ans[0] == -1) cout << "-1\n";
    else{
        cout << ans.size() << endl;
        for(auto x : ans) cout << x + 1 << " "; cout << endl;
    }
}
/**
6 8
1 3 2
1 4 1
3 4 1
2 4 2
2 3 1
3 5 2
5 6 1
2 6 1
*/
