#include<bits/stdc++.h>
#define pb push_back
#define fr first
#define sc second
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXM = 12;

int N, M, used[MAXM], lim[MAXM];
matrix<pair<int, int>> G;
vector<int> path, ans;

void dfs(int u = 1){
    if(!ans.empty()) return;
    bool flag = true;
    for(int i = 0; i < M; i ++){
        if(!used[i]) flag = false;
    }
    if(u == 1 && flag){
        ans = path;
        return;
    }
    for(auto [v, i] : G[u]){
        if(used[i] < lim[i]){
            used[i] ++;
            path.pb(i + 1);
            dfs(v);
            path.pop_back();
            used[i] --;
        }
    }
}

int main(){
    cin >> N >> M;
    G = matrix<pair<int, int>>(N + 1);
    for(int i = 0; i < M; i ++){
        int u, v, t; cin >> u >> v >> t;
        G[u].pb({v, i});
        G[v].pb({u, i});
        lim[i] = t;
    }
    dfs();
    if(ans.empty()) cout << "-1\n";
    else{
        cout << ans.size() << endl;
        for(auto x : ans) cout << x << " "; cout << endl;
    }
}
/**
6 8
1 3 2
1 4 1
3 4 1
2 4 2
2 3 1
3 5 2
5 6 1
2 6 1
*/
