#include<bits/stdc++.h>
#define pb push_back
#define fr first
#define sc second
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXM = 1e6 + 6;

int N, M, mark[MAXM];
matrix<pair<int, int>> G;
vector<int> path;

void dfs(int u = 1){
    /// de(u);
    while(!G[u].empty()){
        int v = G[u].back().fr, i = G[u].back().sc;
        G[u].pop_back();
        if(mark[i]) continue;
        mark[i] = true;
        path.pb(i);
        dfs(v);
    }
}

int main(){
    cin >> N >> M;
    G = matrix<pair<int, int>>(N + 1);
    for(int i = 1; i <= M; i ++){
        int u, v, t; cin >> u >> v >> t;
        G[u].pb({v, i});
        G[v].pb({u, i});
    }
    for(int u = 1; u <= N; u ++){
        if(G[u].size() % 2 == 1){
            cout << "-1\n";
            return 0;
        }
    }
    dfs();
    cout << path.size() << endl;
    for(auto x : path) cout << x << " "; cout << endl;
}
