#include<bits/stdc++.h>
using namespace std;
const int MAXN=1e5+6;
const int MAXM=1e6+6;
int n,m;
int deg[MAXN];
struct edge1
{
    int u,v,type,ind;
};
vector<edge1>all_edges;
vector<edge1>g1[MAXN];
bool state[MAXM];
bool vis[MAXN];
bool vise[MAXM];
int cnt;
void dfs1(int u,int p)
{
    vis[u]=1;
    if(deg[u]%2==1)cnt++;
    for(auto xd:g1[u])
    {
        if(vis[xd.v])continue;
        if(xd.type==1)continue;
        dfs1(xd.v,u);
    }
}
int dfs2(int u,int p)
{
    vis[u]=1;
    int ret=0;
    for(auto xd:g1[u])
    {
        if(vis[xd.v])continue;
        if(xd.type==1)continue;
        int p=dfs2(xd.v,u);
        if(p%2==1)
        {
            state[xd.ind]=!state[xd.ind];
        }
        ret+=p;
    }
    if(deg[u]%2==1)ret++;
    return ret;
}
set<pair<int,int> >final_g[MAXN];
int used[MAXN];
vector<vector<int> >cycles[MAXN];
vector<int>order;
multiset<pair<int,int> >g[MAXN];
vector<int>stack1;
int prv[MAXN];
int prve[MAXN];
vector<int>found_cycle;
void find_cycle(int u,int last,int last_edge)
{
    //cout<<u<<" "<<last<<" "<<last_edge<<endl;
    vis[u]=1;
    if(found_cycle.size()>0){vis[u]=0;return;}
    for(auto xd:final_g[u])
    {
        if(found_cycle.size()>0)return;
        if(xd.second==last_edge)continue;
        if(xd.first==last)
        {
            found_cycle.push_back(xd.second);
            int u1=u;
            while(u1!=last)
            {
                found_cycle.push_back(prve[u1]);
                u1=prv[u1];
            }
            reverse(found_cycle.begin(),found_cycle.end());
            vis[u]=0;
            return;
        }
        if(vis[xd.first])continue;
        prv[xd.first]=u;
        prve[xd.first]=xd.second;
        find_cycle(xd.first,last,xd.second);
        if(found_cycle.size()>0){vis[u]=0;return;}
    }
    vis[u]=0;
}
int move_vert(int v,int e)
{
    int u1=all_edges[abs(e)].u;
    int v1=all_edges[abs(e)].v;
    if(v==v1)swap(u1,v1);
    return v1;
}
void find_euler(int u,int last)
{
    //cout<<u<<" "<<last<<endl;
    for(;;)
    {
        found_cycle.clear();
        find_cycle(u,u,(int)1e9);
        //cout<<"*\n";
        if(found_cycle.size()==0)break;
        vector<int> fc=found_cycle;
        int v1=u;
        for(int j=0;j<fc.size();j++)
        {
            int v2=move_vert(v1,fc[j]);
            final_g[v1].erase({v2,fc[j]});
            final_g[v2].erase({v1,fc[j]});
            v1=v2;
        }
        v1=u;
        for(int j=0;j<fc.size();j++)
        {
            order.push_back(fc[j]);
            v1=move_vert(v1,fc[j]);
            find_euler(v1,u);
        }
    }
}
int main()
{
    cin>>n>>m;
    for(int i=0;i<m;i++)
    {
        int u,v,t;
        cin>>u>>v>>t;
        g1[u].push_back({u,v,t,i});
        g1[v].push_back({v,u,t,i});
        deg[u]++;
        deg[v]++;
        all_edges.push_back({u,v,t,i});
    }
    for(int i=1;i<=n;i++)
    {
        if(!vis[i])
        {
            cnt=0;
            dfs1(i,0);
            if(cnt%2==1)
            {
                cout<<"-1\n";
                return 0;
            }
        }
    }
    memset(vis,0,sizeof(vis));
    for(int i=1;i<=n;i++)
    {
        if(deg[i]%2==1&&!vis[i])
        {
            dfs2(i,0);
        }
    }
    for(int i=0;i<m;i++)
    {
        int u=all_edges[i].u;
        int v=all_edges[i].v;
        int ind=all_edges[i].ind;
        final_g[u].insert({v,ind});
        final_g[v].insert({u,ind});
        used[i]=1;
        if(state[i]==1)
        {
            used[i]=2;
            final_g[u].insert({v,-ind});
            final_g[v].insert({u,-ind});
        }
    }
    /*for(int i=1;i<=n;i++)
    {
        cout<<i<<":";
        for(auto xd:final_g[i])cout<<" "<<xd.first;
        cout<<endl;
    }*/
    //naj-lesno 1
    //cout<<1<<endl;
    //eulerov cikyl :(
    memset(vis,0,sizeof(vis));
    find_euler(1,0);
    cout<<order.size()<<endl;
    for(int i=0;i<order.size();i++)
    {
        cout<<abs(order[i])+1<<" ";
    }
    cout<<endl;
    /*for(int i=0;i<order.size();i++)
    {
        cout<<all_edges[abs(order[i])].u<<" ";
        cout<<all_edges[abs(order[i])].v<<"\n";
    }*/
return 0;
}
