#include<bits/stdc++.h>
using namespace std;
const int MAXN=1e5+6;
const int MAXM=1e6+6;
int n,m;
int deg[MAXN];
struct edge1
{
    int u,v,type,ind;
};
vector<edge1>all_edges;
vector<edge1>g1[MAXN];
bool state[MAXM];
bool vis[MAXN];
int cnt;
void dfs1(int u,int p)
{
    vis[u]=1;
    if(deg[u]%2==1)cnt++;
    for(auto xd:g1[u])
    {
        if(vis[xd.v])continue;
        if(xd.type==1)continue;
        dfs1(xd.v,u);
    }
}
int dfs2(int u,int p)
{
    vis[u]=1;
    int ret=0;
    for(auto xd:g1[u])
    {
        if(vis[xd.v])continue;
        if(xd.type==1)continue;
        int p=dfs2(xd.v,u);
        if(p%2==1)
        {
            state[xd.ind]=!state[xd.ind];
        }
        ret+=p;
    }
    if(deg[u]%2==1)ret++;
    return ret;
}
set<pair<int,int> >final_g[MAXN];
int used[MAXN];
vector<vector<int> >cycles[MAXN];
stack<int>vertices;
stack<int>last_edge;
void remove_edge(int ind)
{
    int u=all_edges[abs(ind)-1].u;
    int v=all_edges[abs(ind)-1].v;
    final_g[u].erase({v,ind});
    final_g[v].erase({u,ind});
}
void print(stack<int>st)
{
    while(!st.empty())
    {
        cout<<st.top()<<" ";
        st.pop();
    }
    cout<<endl;
}
vector<int>cikylche;
void find_cycles(int u,int le)
{
    //cout<<"   "<<u<<endl;
    //cout<<" "<<vertices.size()<<" "<<last_edge.size()<<endl;
    //print(vertices);
    vis[u]=1;
    vertices.push(u);
    last_edge.push(le);
    vector<pair<int,int> >neigh;
    for(auto xd:final_g[u])neigh.push_back(xd);
    for(auto xd:neigh)
    {
        //cout<<u<<"->"<<xd.first<<endl;
        if(vertices.top()!=u)return;
        if(last_edge.size()>0&&xd.second==last_edge.top())continue;
        //cout<<u<<"->"<<xd.first<<endl;
        if(vis[xd.first])
        {
            //cout<<"???\n";
            //namereili sme cikyl
            int u1=u;
            cikylche.clear();
            //cout<<"uh? "<<xd.first<<endl;
            //cout<<vertices.size()<<" "<<last_edge.size()<<endl;
            while(u1!=xd.first)
            {
                //cout<<u1<<endl;
                if(last_edge.size()==0||vertices.size()==0)
                {
                    cout<<0<<endl;
                    exit(0);
                }
                cikylche.push_back(last_edge.top());
                last_edge.pop();
                vis[vertices.top()]=0;
                vertices.pop();
                u1=vertices.top();
            }
            //cout<<"***\n";
            reverse(cikylche.begin(),cikylche.end());
            cikylche.push_back(xd.second);
            cycles[xd.first].push_back(cikylche);
            //cout<<"&&&\n";
            break;
        }
        else if(final_g[u].find(xd)!=final_g[u].end())
        {
            //cout<<"alo "<<u<<" "<<xd.first<<" "<<xd.second<<endl;
            find_cycles(xd.first,xd.second);
            if(vertices.top()!=u)return;
            else
            {
                /*cout<<"===============\n";
                cout<<vertices.size()<<" "<<last_edge.size()<<endl;
                cout<<"===============\n";*/
            }
        }
        if(vertices.top()!=u)return;
    }
    if(cikylche.size()>0)
    {
        for(auto xd:cikylche)
        {
            remove_edge(xd);
        }
    }
    if(vertices.top()!=u)return;
    vis[u]=0;
                if(last_edge.size()==0||vertices.size()==0)
                {
                    cout<<0<<endl;
                    exit(0);
                }
    vertices.pop();
    last_edge.pop();
}
vector<int>order;
mt19937 mt(34234);
int move_vert(int v,int e)
{
    int u1=all_edges[abs(e)-1].u;
    int v1=all_edges[abs(e)-1].v;
    if(v==v1)swap(u1,v1);
    return v1;
}
void print_euler(int u)
{
    while(cycles[u].size()>0)
    {
        int u1=u;
        for(auto dx:cycles[u].back())
        {
            order.push_back(dx);
            u1=move_vert(u1,dx);
            if(u1!=u)
            {
                print_euler(u1);
            }
        }
        cycles[u].pop_back();
    }
}
int main()
{
    cin>>n>>m;
    for(int i=0;i<m;i++)
    {
        int u,v,t;
        cin>>u>>v>>t;
        g1[u].push_back({u,v,t,i});
        g1[v].push_back({v,u,t,i});
        deg[u]++;
        deg[v]++;
        all_edges.push_back({u,v,t,i});
    }
    for(int i=1;i<=n;i++)
    {
        shuffle(g1[i].begin(),g1[i].end(),mt);
        if(!vis[i])
        {
            cnt=0;
            dfs1(i,0);
            if(cnt%2==1)
            {
                cout<<"-1\n";
                return 0;
            }
        }
    }
    memset(vis,0,sizeof(vis));
    for(int i=1;i<=n;i++)
    {
        if(deg[i]%2==1&&!vis[i])
        {
            dfs2(i,0);
        }
    }
    for(int i=0;i<m;i++)
    {
        int u=all_edges[i].u;
        int v=all_edges[i].v;
        int ind=all_edges[i].ind;
        final_g[u].insert({v,ind+1});
        final_g[v].insert({u,ind+1});
        used[i]=1;
        if(state[i]==1)
        {
            used[i]=2;
            final_g[u].insert({v,-ind-1});
            final_g[v].insert({u,-ind-1});
        }
    }
    memset(vis,0,sizeof(vis));
    for(int i=1;i<=n;i++)
    {
        if(final_g[i].size()>0)
        {
            vis[i]=1;
            while(!vertices.empty())vertices.pop();
            while(!last_edge.empty())last_edge.pop();
            //vertices.push(i);
            find_cycles(i,(int)1e9);
            vis[i]=0;
        }
    }
    //cerr<<cnt1<<endl;
    //cout<<1<<endl;
    //return 0;
    /*cout<<"\n\n\n\n\n\n";
    for(int i=1;i<=n;i++)
    {
        cout<<i<<":\n";
        for(auto xd:cycles[i])
        {
            for(auto dx:xd)cout<<dx<<" ";
            cout<<endl;
            for(auto dx:xd)
            {
                cout<<"("<<all_edges[abs(dx)-1].u<<","<<all_edges[abs(dx)-1].v<<") ";
            }
            cout<<endl;
        }
    }*/
    //find_euler(1,0);
    print_euler(1);
    cout<<order.size()<<endl;
    for(int i=0;i<order.size();i++)
    {
        cout<<abs(order[i])<<" ";
    }
    cout<<endl;
return 0;
}
