#include<bits/stdc++.h>
#pragma GCC optimize ("Ofast")
#pragma GCC target ("sse4")
using namespace std;
const int MAXN=1e5+6;
const int MAXM=1e6+6;
int n,m;
int deg[MAXN];
struct edge1
{
    int u,v,type,ind;
};
vector<edge1>all_edges;
vector<edge1>g1[MAXN];
bool state[MAXM];
bool vis[MAXN];
int cnt;
void dfs1(int u,int p)
{
    vis[u]=1;
    if(deg[u]%2==1)++cnt;
    for(auto xd:g1[u])
    {
        if(vis[xd.v])continue;
        if(xd.type==1)continue;
        dfs1(xd.v,u);
    }
}
int dfs2(int u,int p)
{
    vis[u]=1;
    int ret=0;
    for(auto xd:g1[u])
    {
        if(vis[xd.v])continue;
        if(xd.type==1)continue;
        int p=dfs2(xd.v,u);
        if(p%2==1)
        {
            state[xd.ind]=!state[xd.ind];
        }
        ret+=p;
    }
    if(deg[u]%2==1)++ret;
    return ret;
}
set<pair<int,int> >final_g[MAXN];
int used[MAXM];
vector<vector<int> >cycles[MAXN];
stack<int>vertices;
stack<int>last_edge;
void remove_edge(int ind)
{
    int u=all_edges[abs(ind)-1].u;
    int v=all_edges[abs(ind)-1].v;
    final_g[u].erase({v,ind});
    final_g[v].erase({u,ind});
}
void print(stack<int>st)
{
    while(!st.empty())
    {
        cout<<st.top()<<" ";
        st.pop();
    }
    cout<<endl;
}
vector<int>cikylche;
void find_cycles(int u,int le)
{
    vis[u]=1;
    vertices.push(u);
    last_edge.push(le);
    vector<pair<int,int> >neigh;
    for(auto xd:final_g[u])neigh.push_back(xd);
    for(auto xd:neigh)
    {
        if(vertices.top()!=u)return;
        if(last_edge.size()>0&&xd.second==last_edge.top())continue;
        if(vis[xd.first])
        {
            int u1=u;
            cikylche.clear();
            cikylche.push_back(xd.second);
            while(u1!=xd.first)
            {
                cikylche.push_back(last_edge.top());
                last_edge.pop();
                vis[vertices.top()]=0;
                vertices.pop();
                u1=vertices.top();
            }
            cycles[xd.first].push_back(cikylche);
            break;
        }
        else if(final_g[u].find(xd)!=final_g[u].end())
        {
            find_cycles(xd.first,xd.second);
            if(vertices.top()!=u)return;
        }
        if(vertices.top()!=u)return;
    }
    if(cikylche.size()>0)
    {
        for(auto xd:cikylche)
        {
            remove_edge(xd);
        }
    }
    if(vertices.top()!=u)return;
    vis[u]=0;
    vertices.pop();
    last_edge.pop();
}
vector<int>order;
mt19937 mt(16644);
int move_vert(int v,int e)
{
    int u1=all_edges[abs(e)-1].v;
    int v1=all_edges[abs(e)-1].u;
    if(v==v1)swap(u1,v1);
    if(u1!=v&&v1!=v)
    {
        cout<<"-1\n";
        exit(0);
    }
    return v1;
}
bool vis1000[MAXN];
void print_euler(int u)
{
    vis1000[u]=1;
    while(cycles[u].size()>0)
    {
        int u1=u;
        for(auto dx:cycles[u].back())
        {
            order.push_back(dx);
            u1=move_vert(u1,dx);
            if(u1!=u&&vis1000[u1]==0)
            {
                print_euler(u1);
            }
        }
        cycles[u].pop_back();
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
    for(int i=0;i<m;++i)
    {
        int u,v,t;
        cin>>u>>v>>t;
        g1[u].push_back({u,v,t,i});
        g1[v].push_back({v,u,t,i});
        ++deg[u];
        ++deg[v];
        all_edges.push_back({u,v,t,i});
    }
    for(int i=1;i<=n;++i)
    {
        shuffle(g1[i].begin(),g1[i].end(),mt);
        if(!vis[i])
        {
            cnt=0;
            dfs1(i,0);
            if(cnt%2==1)
            {
                cout<<"-1\n";
                return 0;
            }
        }
    }
    memset(vis,0,sizeof(vis));
    for(int i=1;i<=n;++i)
    {
        if(deg[i]%2==1&&!vis[i])
        {
            dfs2(i,0);
        }
    }
    for(int i=0;i<m;++i)
    {
        int u=all_edges[i].u;
        int v=all_edges[i].v;
        int ind=all_edges[i].ind;
        final_g[u].insert({v,ind+1});
        final_g[v].insert({u,ind+1});
        used[i]=1;
        if(state[i]==1)
        {
            used[i]=2;
            final_g[u].insert({v,-ind-1});
            final_g[v].insert({u,-ind-1});
        }
    }
    memset(vis,0,sizeof(vis));
    for(int i=1;i<=n;++i)
    {
        if(final_g[i].size()>0)
        {
            vis[i]=1;
            while(!vertices.empty())vertices.pop();
            while(!last_edge.empty())last_edge.pop();

            find_cycles(i,(int)1e9);
            vis[i]=0;
        }
    }
    print_euler(1);
    cout<<order.size()<<"\n";
    for(int i=0;i<order.size();++i)
    {
        cout<<abs(order[i])<<" ";
    }
    cout<<"\n";
return 0;
}
