#include<bits/stdc++.h>
#define endl '\n'
#define ll long long
using namespace std;
const ll MAX_N = 2e6+2;
string s[MAX_N];
ll max_sz = 0;
ll n,m,k;
struct st
{
    ll idx;
    ll res[6];
    ll sum;
} a[MAX_N];
bool cmp(st &a, st &b)
{
    if(a.sum == b.sum)
    {
        return a.idx < b.idx;
    }
    return a.sum > b.sum;
}
ll base = 151;
ll MOD = 1e9+7;
map<ll,ll> hashtoid;
map<ll,string> idtoname;
map<string,ll> nametohash;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m>>k;
    for(ll i=0; i<n; i++)
    {
        cin>>s[i];
        max_sz = max(max_sz, (ll)s[i].size());
    }
    for(ll i=0; i<n; i++)
    {
        while(s[i].size() < max_sz)
        {
            s[i] = s[i]+'$';
        }
    }
    sort(s,s+n);
    for(ll i=0; i<n; i++)
    {
        string temp = "";
        for(ll j=0; j<s[i].size(); j++)
        {
            if(s[i][j] == '$') break;
            temp = temp + s[i][j];
        }
        s[i] = temp;
    }
    for(ll i=0; i<n; i++)
    {
        ll temp_hash = 0;
        for(ll j=0; j<s[i].size(); j++)
        {
            temp_hash *= base;
            temp_hash += (s[i][j]-'a'+1);
            temp_hash %= MOD;
        }
        hashtoid[temp_hash] = i;
        nametohash[s[i]] = temp_hash;
        idtoname[i] = s[i];
        a[i].idx = i;
    }
    string name;
    for(ll i=0; i<m; i++)
    {
        cin>>name;
        ll cur_hash = nametohash[name];
        ll id = hashtoid[cur_hash];
        ll new_val;
        for(ll j=0; j<k; j++)
        {
            cin>>new_val;
            a[id].res[j] = max(a[id].res[j], new_val);
        }
    }
    for(ll i=0; i<n; i++)
    {
        for(ll j=0; j<k; j++)
        {
            a[i].sum += a[i].res[j];
        }
    }
    sort(a,a+n,cmp);
    for(ll i=0; i<n; i++)
    {
        cout<<idtoname[a[i].idx]<<" "<<a[i].sum<<" ";
        for(ll j=0; j<k; j++)
        {
            cout<<a[i].res[j]<<" ";
        }
        cout<<endl;
    }
}
/**
3 3 3
b
a
aa
b 1 9 0
a 13 12 0
aa 10 10 10
*/
