#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAX_N = 1e5+2;
const int MAX_M = 1e6+2;
vector< pair<int,int> > adj[MAX_N];
int n,m,u0,v0,t0;
int br = 0;
int max_use[MAX_M];
int used[MAX_M];
int po[MAX_N];
pair<int,int> x;
void dfs(int cur, int par)
{
    for(;po[cur]<adj[cur].size(); po[cur]++)
    {
        x = adj[cur][po[cur]];
        if(used[x.second] <= max_use[x.second])
        {
            used[x.second]++;
            st1.push(x.first);
            ste1.push(x.second);
            dfs(x.first);
        }
    }
    st2.push(st1.top());
    ste2.push(ste1.top());
    st1.pop();
    ste1.pop();
}
void euler_cycle(int s)
{
    st1.push(s);
    ste1.push(0);
    dfs(s);
    if(!st2.empty()) ste2.pop();
    if(ste2.size() != m)
    {
        cout<<-1<<endl;
    }
    else
    {
        cout<<m<<endl;
        while(!ste2.empty())
        {
            cout<<ste2.top()<<" ";
            ste2.pop();
        }
        cout<<endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
    for(int i=1; i<=m; i++)
    {
        cin>>u0>>v0>>t0;
        max_use[i] = t0;
        adj[u0].push_back({v0,i});
        adj[v0].push_back({u0,i});
    }
    for(int i=1; i<=n; i++)
    {
        if(adj[i].size()%2 == 1)
        {
            cout<<-1<<endl;
            return 0;
        }
    }
    euler_cycle(1);
}
/**
11 13
1 2 1
2 3 1
3 4 1
4 5 1
5 1 1
3 8 1
8 7 1
7 6 1
6 3 1
6 9 1
9 10 1
10 11 1
11 6 1

3 7
1 2 1
1 2 1
1 2 1
2 3 1
2 3 1
2 3 1
1 3 1
*/

